=begin
#OSDN REST API v0 beta

#OSDN REST API. Currently this API is experimental release. Pelase refer documentation on https://osdn.net/projects/osdn-codes/wiki/APIGuide and you can get client libraries from https://osdn.net/projects/osdn-codes/releases/p14859 . 

OpenAPI spec version: 0.0.20171120
Contact: admin@osdn.net
Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module OSDNClient
  class ProjectTicketApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # Create project ticket
    # @param id_or_name numeric project id or project name
    # @param name Project ticket name (title)
    # @param description Project ticket description details
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :milestone_id numeric project ticket milestone id
    # @option opts [Integer] :component_id numeric project ticket component id
    # @option opts [Integer] :priority project ticket priority (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :severity project ticket severity (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :owner numeric project ticket owner user id
    # @return [ProjectTicketItem]
    def create_project_ticket(id_or_name, name, description, type_id, opts = {})
      data, _status_code, _headers = create_project_ticket_with_http_info(id_or_name, name, description, type_id, opts)
      return data
    end

    # 
    # Create project ticket
    # @param id_or_name numeric project id or project name
    # @param name Project ticket name (title)
    # @param description Project ticket description details
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :milestone_id numeric project ticket milestone id
    # @option opts [Integer] :component_id numeric project ticket component id
    # @option opts [Integer] :priority project ticket priority (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :severity project ticket severity (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :owner numeric project ticket owner user id
    # @return [Array<(ProjectTicketItem, Fixnum, Hash)>] ProjectTicketItem data, response status code and response headers
    def create_project_ticket_with_http_info(id_or_name, name, description, type_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.create_project_ticket ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.create_project_ticket" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectTicketApi.create_project_ticket" if name.nil?
      # verify the required parameter 'description' is set
      fail ArgumentError, "Missing the required parameter 'description' when calling ProjectTicketApi.create_project_ticket" if description.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectTicketApi.create_project_ticket" if type_id.nil?
      if opts[:'priority'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"priority"]" when calling ProjectTicketApi.create_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'priority'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"priority"]" when calling ProjectTicketApi.create_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'severity'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"severity"]" when calling ProjectTicketApi.create_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'severity'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"severity"]" when calling ProjectTicketApi.create_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'owner'] < 101.0
        fail ArgumentError, 'invalid value for "opts[:"owner"]" when calling ProjectTicketApi.create_project_ticket, must be greater than or equal to 101.0.'
      end

      # resource path
      local_var_path = "/project/{id_or_name}/ticket".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["description"] = description
      form_params["type_id"] = type_id
      form_params["milestone_id"] = opts[:'milestone_id'] if !opts[:'milestone_id'].nil?
      form_params["component_id"] = opts[:'component_id'] if !opts[:'component_id'].nil?
      form_params["priority"] = opts[:'priority'] if !opts[:'priority'].nil?
      form_params["severity"] = opts[:'severity'] if !opts[:'severity'].nil?
      form_params["owner"] = opts[:'owner'] if !opts[:'owner'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketItem')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#create_project_ticket\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create new project ticket comment of spscified project.
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param comment Ticket comment text
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketComment]
    def create_project_ticket_comment(id_or_name, ticket_id, comment, opts = {})
      data, _status_code, _headers = create_project_ticket_comment_with_http_info(id_or_name, ticket_id, comment, opts)
      return data
    end

    # 
    # Create new project ticket comment of spscified project.
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param comment Ticket comment text
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketComment, Fixnum, Hash)>] ProjectTicketComment data, response status code and response headers
    def create_project_ticket_comment_with_http_info(id_or_name, ticket_id, comment, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.create_project_ticket_comment ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.create_project_ticket_comment" if id_or_name.nil?
      # verify the required parameter 'ticket_id' is set
      fail ArgumentError, "Missing the required parameter 'ticket_id' when calling ProjectTicketApi.create_project_ticket_comment" if ticket_id.nil?
      # verify the required parameter 'comment' is set
      fail ArgumentError, "Missing the required parameter 'comment' when calling ProjectTicketApi.create_project_ticket_comment" if comment.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/{ticket_id}/comment".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'ticket_id' + '}', ticket_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["comment"] = comment

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketComment')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#create_project_ticket_comment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create new project ticket component of spscified project.
    # @param id_or_name numeric project id or project name
    # @param name Ticket component name
    # @param description Ticket component description
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :owner Ticket componet owner user_id
    # @option opts [BOOLEAN] :active Ticket componet will be shown the component select list when this parameter is true
    # @return [Array<ProjectTicketComponent>]
    def create_project_ticket_component(id_or_name, name, description, opts = {})
      data, _status_code, _headers = create_project_ticket_component_with_http_info(id_or_name, name, description, opts)
      return data
    end

    # 
    # Create new project ticket component of spscified project.
    # @param id_or_name numeric project id or project name
    # @param name Ticket component name
    # @param description Ticket component description
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :owner Ticket componet owner user_id
    # @option opts [BOOLEAN] :active Ticket componet will be shown the component select list when this parameter is true
    # @return [Array<(Array<ProjectTicketComponent>, Fixnum, Hash)>] Array<ProjectTicketComponent> data, response status code and response headers
    def create_project_ticket_component_with_http_info(id_or_name, name, description, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.create_project_ticket_component ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.create_project_ticket_component" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectTicketApi.create_project_ticket_component" if name.nil?
      # verify the required parameter 'description' is set
      fail ArgumentError, "Missing the required parameter 'description' when calling ProjectTicketApi.create_project_ticket_component" if description.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/component".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["description"] = description
      form_params["owner"] = opts[:'owner'] if !opts[:'owner'].nil?
      form_params["active"] = opts[:'active'] if !opts[:'active'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectTicketComponent>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#create_project_ticket_component\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create new project ticket milestone of spscified project.
    # @param id_or_name numeric project id or project name
    # @param name Ticket milestone name
    # @param description Ticket milestone description
    # @param [Hash] opts the optional parameters
    # @option opts [DateTime] :start Ticket milestone start date
    # @option opts [DateTime] :_end Ticket milestone due date
    # @return [ProjectTicketMilestone]
    def create_project_ticket_milestone(id_or_name, name, description, opts = {})
      data, _status_code, _headers = create_project_ticket_milestone_with_http_info(id_or_name, name, description, opts)
      return data
    end

    # 
    # Create new project ticket milestone of spscified project.
    # @param id_or_name numeric project id or project name
    # @param name Ticket milestone name
    # @param description Ticket milestone description
    # @param [Hash] opts the optional parameters
    # @option opts [DateTime] :start Ticket milestone start date
    # @option opts [DateTime] :_end Ticket milestone due date
    # @return [Array<(ProjectTicketMilestone, Fixnum, Hash)>] ProjectTicketMilestone data, response status code and response headers
    def create_project_ticket_milestone_with_http_info(id_or_name, name, description, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.create_project_ticket_milestone ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.create_project_ticket_milestone" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectTicketApi.create_project_ticket_milestone" if name.nil?
      # verify the required parameter 'description' is set
      fail ArgumentError, "Missing the required parameter 'description' when calling ProjectTicketApi.create_project_ticket_milestone" if description.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/milestone".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["description"] = description
      form_params["start"] = opts[:'start'] if !opts[:'start'].nil?
      form_params["end"] = opts[:'_end'] if !opts[:'_end'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketMilestone')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#create_project_ticket_milestone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create new project ticket type of spscified project.
    # @param id_or_name numeric project id or project name
    # @param name Ticket type name
    # @param description Ticket type description
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :is_public if set as false, this type will be shown to project members only.
    # @return [ProjectTicketType]
    def create_project_ticket_type(id_or_name, name, description, opts = {})
      data, _status_code, _headers = create_project_ticket_type_with_http_info(id_or_name, name, description, opts)
      return data
    end

    # 
    # Create new project ticket type of spscified project.
    # @param id_or_name numeric project id or project name
    # @param name Ticket type name
    # @param description Ticket type description
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :is_public if set as false, this type will be shown to project members only.
    # @return [Array<(ProjectTicketType, Fixnum, Hash)>] ProjectTicketType data, response status code and response headers
    def create_project_ticket_type_with_http_info(id_or_name, name, description, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.create_project_ticket_type ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.create_project_ticket_type" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectTicketApi.create_project_ticket_type" if name.nil?
      # verify the required parameter 'description' is set
      fail ArgumentError, "Missing the required parameter 'description' when calling ProjectTicketApi.create_project_ticket_type" if description.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["description"] = description
      form_params["is_public"] = opts[:'is_public'] if !opts[:'is_public'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketType')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#create_project_ticket_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create project ticket type instructions for the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param instruction Ticket submit instruction for the type
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketTypeInstructionPerLanguage]
    def create_project_ticket_type_instruction(id_or_name, type_id, language_code, instruction, opts = {})
      data, _status_code, _headers = create_project_ticket_type_instruction_with_http_info(id_or_name, type_id, language_code, instruction, opts)
      return data
    end

    # 
    # Create project ticket type instructions for the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param instruction Ticket submit instruction for the type
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketTypeInstructionPerLanguage, Fixnum, Hash)>] ProjectTicketTypeInstructionPerLanguage data, response status code and response headers
    def create_project_ticket_type_instruction_with_http_info(id_or_name, type_id, language_code, instruction, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.create_project_ticket_type_instruction ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.create_project_ticket_type_instruction" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectTicketApi.create_project_ticket_type_instruction" if type_id.nil?
      # verify the required parameter 'language_code' is set
      fail ArgumentError, "Missing the required parameter 'language_code' when calling ProjectTicketApi.create_project_ticket_type_instruction" if language_code.nil?
      # verify the required parameter 'instruction' is set
      fail ArgumentError, "Missing the required parameter 'instruction' when calling ProjectTicketApi.create_project_ticket_type_instruction" if instruction.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}/instruction".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["language_code"] = language_code
      form_params["instruction"] = instruction

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketTypeInstructionPerLanguage')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#create_project_ticket_type_instruction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete project ticket component
    # @param id_or_name numeric project id or project name
    # @param component_id numeric project ticket component id
    # @param migrate_to Tickets that assigned to delete target will be migrate to the ticket component_id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_project_ticket_component(id_or_name, component_id, migrate_to, opts = {})
      delete_project_ticket_component_with_http_info(id_or_name, component_id, migrate_to, opts)
      return nil
    end

    # 
    # Delete project ticket component
    # @param id_or_name numeric project id or project name
    # @param component_id numeric project ticket component id
    # @param migrate_to Tickets that assigned to delete target will be migrate to the ticket component_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_project_ticket_component_with_http_info(id_or_name, component_id, migrate_to, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.delete_project_ticket_component ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.delete_project_ticket_component" if id_or_name.nil?
      # verify the required parameter 'component_id' is set
      fail ArgumentError, "Missing the required parameter 'component_id' when calling ProjectTicketApi.delete_project_ticket_component" if component_id.nil?
      # verify the required parameter 'migrate_to' is set
      fail ArgumentError, "Missing the required parameter 'migrate_to' when calling ProjectTicketApi.delete_project_ticket_component" if migrate_to.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/component/{component_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'component_id' + '}', component_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'migrate_to'] = migrate_to

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#delete_project_ticket_component\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete project ticket milestone
    # @param id_or_name numeric project id or project name
    # @param milestone_id numeric project ticket milestone id
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :migrate_to Tickets that assigned to delete target will be migrate to the ticket milestone_id
    # @return [nil]
    def delete_project_ticket_milestone(id_or_name, milestone_id, opts = {})
      delete_project_ticket_milestone_with_http_info(id_or_name, milestone_id, opts)
      return nil
    end

    # 
    # Delete project ticket milestone
    # @param id_or_name numeric project id or project name
    # @param milestone_id numeric project ticket milestone id
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :migrate_to Tickets that assigned to delete target will be migrate to the ticket milestone_id
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_project_ticket_milestone_with_http_info(id_or_name, milestone_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.delete_project_ticket_milestone ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.delete_project_ticket_milestone" if id_or_name.nil?
      # verify the required parameter 'milestone_id' is set
      fail ArgumentError, "Missing the required parameter 'milestone_id' when calling ProjectTicketApi.delete_project_ticket_milestone" if milestone_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/milestone/{milestone_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'milestone_id' + '}', milestone_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'migrate_to'] = opts[:'migrate_to'] if !opts[:'migrate_to'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#delete_project_ticket_milestone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete project ticket type
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param migrate_to Tickets that assigned to delete target will be migrate to the ticket type_id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_project_ticket_type(id_or_name, type_id, migrate_to, opts = {})
      delete_project_ticket_type_with_http_info(id_or_name, type_id, migrate_to, opts)
      return nil
    end

    # 
    # Delete project ticket type
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param migrate_to Tickets that assigned to delete target will be migrate to the ticket type_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_project_ticket_type_with_http_info(id_or_name, type_id, migrate_to, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.delete_project_ticket_type ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.delete_project_ticket_type" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectTicketApi.delete_project_ticket_type" if type_id.nil?
      # verify the required parameter 'migrate_to' is set
      fail ArgumentError, "Missing the required parameter 'migrate_to' when calling ProjectTicketApi.delete_project_ticket_type" if migrate_to.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'migrate_to'] = migrate_to

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#delete_project_ticket_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete project ticket type instructions on the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_project_ticket_type_instruction(id_or_name, type_id, language_code, opts = {})
      delete_project_ticket_type_instruction_with_http_info(id_or_name, type_id, language_code, opts)
      return nil
    end

    # 
    # Delete project ticket type instructions on the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_project_ticket_type_instruction_with_http_info(id_or_name, type_id, language_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.delete_project_ticket_type_instruction ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.delete_project_ticket_type_instruction" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectTicketApi.delete_project_ticket_type_instruction" if type_id.nil?
      # verify the required parameter 'language_code' is set
      fail ArgumentError, "Missing the required parameter 'language_code' when calling ProjectTicketApi.delete_project_ticket_type_instruction" if language_code.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}/instruction/{language_code}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s).sub('{' + 'language_code' + '}', language_code.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#delete_project_ticket_type_instruction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketItem]
    def get_project_ticket(id_or_name, ticket_id, opts = {})
      data, _status_code, _headers = get_project_ticket_with_http_info(id_or_name, ticket_id, opts)
      return data
    end

    # 
    # Get project ticket
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketItem, Fixnum, Hash)>] ProjectTicketItem data, response status code and response headers
    def get_project_ticket_with_http_info(id_or_name, ticket_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.get_project_ticket ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.get_project_ticket" if id_or_name.nil?
      # verify the required parameter 'ticket_id' is set
      fail ArgumentError, "Missing the required parameter 'ticket_id' when calling ProjectTicketApi.get_project_ticket" if ticket_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/{ticket_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'ticket_id' + '}', ticket_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketItem')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#get_project_ticket\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket component
    # @param id_or_name numeric project id or project name
    # @param component_id numeric project ticket component id
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketComponent]
    def get_project_ticket_component(id_or_name, component_id, opts = {})
      data, _status_code, _headers = get_project_ticket_component_with_http_info(id_or_name, component_id, opts)
      return data
    end

    # 
    # Get project ticket component
    # @param id_or_name numeric project id or project name
    # @param component_id numeric project ticket component id
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketComponent, Fixnum, Hash)>] ProjectTicketComponent data, response status code and response headers
    def get_project_ticket_component_with_http_info(id_or_name, component_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.get_project_ticket_component ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.get_project_ticket_component" if id_or_name.nil?
      # verify the required parameter 'component_id' is set
      fail ArgumentError, "Missing the required parameter 'component_id' when calling ProjectTicketApi.get_project_ticket_component" if component_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/component/{component_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'component_id' + '}', component_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketComponent')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#get_project_ticket_component\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket milestone of spscified milestone_id.
    # @param id_or_name numeric project id or project name
    # @param milestone_id numeric project ticket milestone id
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketMilestone]
    def get_project_ticket_milestone(id_or_name, milestone_id, opts = {})
      data, _status_code, _headers = get_project_ticket_milestone_with_http_info(id_or_name, milestone_id, opts)
      return data
    end

    # 
    # Get project ticket milestone of spscified milestone_id.
    # @param id_or_name numeric project id or project name
    # @param milestone_id numeric project ticket milestone id
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketMilestone, Fixnum, Hash)>] ProjectTicketMilestone data, response status code and response headers
    def get_project_ticket_milestone_with_http_info(id_or_name, milestone_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.get_project_ticket_milestone ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.get_project_ticket_milestone" if id_or_name.nil?
      # verify the required parameter 'milestone_id' is set
      fail ArgumentError, "Missing the required parameter 'milestone_id' when calling ProjectTicketApi.get_project_ticket_milestone" if milestone_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/milestone/{milestone_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'milestone_id' + '}', milestone_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketMilestone')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#get_project_ticket_milestone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket type
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketType]
    def get_project_ticket_type(id_or_name, type_id, opts = {})
      data, _status_code, _headers = get_project_ticket_type_with_http_info(id_or_name, type_id, opts)
      return data
    end

    # 
    # Get project ticket type
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketType, Fixnum, Hash)>] ProjectTicketType data, response status code and response headers
    def get_project_ticket_type_with_http_info(id_or_name, type_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.get_project_ticket_type ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.get_project_ticket_type" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectTicketApi.get_project_ticket_type" if type_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketType')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#get_project_ticket_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket type instructions on the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketTypeInstructionPerLanguage]
    def get_project_ticket_type_instruction(id_or_name, type_id, language_code, opts = {})
      data, _status_code, _headers = get_project_ticket_type_instruction_with_http_info(id_or_name, type_id, language_code, opts)
      return data
    end

    # 
    # Get project ticket type instructions on the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketTypeInstructionPerLanguage, Fixnum, Hash)>] ProjectTicketTypeInstructionPerLanguage data, response status code and response headers
    def get_project_ticket_type_instruction_with_http_info(id_or_name, type_id, language_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.get_project_ticket_type_instruction ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.get_project_ticket_type_instruction" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectTicketApi.get_project_ticket_type_instruction" if type_id.nil?
      # verify the required parameter 'language_code' is set
      fail ArgumentError, "Missing the required parameter 'language_code' when calling ProjectTicketApi.get_project_ticket_type_instruction" if language_code.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}/instruction/{language_code}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s).sub('{' + 'language_code' + '}', language_code.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketTypeInstructionPerLanguage')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#get_project_ticket_type_instruction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project ticket type instructions on the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param instruction Ticket submit instruction for the type
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketTypeInstructionPerLanguage]
    def get_project_ticket_type_instruction_0(id_or_name, type_id, language_code, instruction, opts = {})
      data, _status_code, _headers = get_project_ticket_type_instruction_0_with_http_info(id_or_name, type_id, language_code, instruction, opts)
      return data
    end

    # 
    # Update project ticket type instructions on the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param instruction Ticket submit instruction for the type
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketTypeInstructionPerLanguage, Fixnum, Hash)>] ProjectTicketTypeInstructionPerLanguage data, response status code and response headers
    def get_project_ticket_type_instruction_0_with_http_info(id_or_name, type_id, language_code, instruction, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.get_project_ticket_type_instruction_0 ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.get_project_ticket_type_instruction_0" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectTicketApi.get_project_ticket_type_instruction_0" if type_id.nil?
      # verify the required parameter 'language_code' is set
      fail ArgumentError, "Missing the required parameter 'language_code' when calling ProjectTicketApi.get_project_ticket_type_instruction_0" if language_code.nil?
      # verify the required parameter 'instruction' is set
      fail ArgumentError, "Missing the required parameter 'instruction' when calling ProjectTicketApi.get_project_ticket_type_instruction_0" if instruction.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}/instruction/{language_code}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s).sub('{' + 'language_code' + '}', language_code.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["instruction"] = instruction

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketTypeInstructionPerLanguage')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#get_project_ticket_type_instruction_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # List project ticket order by submit date descending
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :status Tickets are assigned to these type_ids
    # @option opts [Array<Integer>] :type_id Listing tickets are assigned to these type_ids
    # @option opts [Array<Integer>] :not_type_id Listing tickets are NOT assigned to these type_ids
    # @option opts [Array<Integer>] :component_id Listing tickets are assigned to these component_ids (If you want to indicate component is not assigned, please use component_id &#x3D; 0)
    # @option opts [Array<Integer>] :not_component_id Listing tickets are NOT assigned to these component_ids (If you want to indicate component is not assigned, please use component_id &#x3D; 0)
    # @option opts [Array<Integer>] :milestone_id Listing tickets are assigned to these milestone_ids (If you want to indicate milestone is not assigned, please use milestone_id &#x3D; 0)
    # @option opts [Array<Integer>] :not_milestone_id Listing tickets are NOT assigned to these milestone_ids (milestone_id &#x3D; 0 means milestone not assigned)
    # @option opts [Integer] :max_priority Listing equal or lower priority tickets
    # @option opts [Integer] :min_priority Listing equal or higher priority tickets
    # @option opts [Integer] :priority Listing tickets have this priority
    # @option opts [Integer] :max_severity Listing equal or lower severity tickets
    # @option opts [Integer] :min_severity Listing equal or higher severity tickets
    # @option opts [Integer] :severity Listing tickets have this severity
    # @option opts [Array<Integer>] :owner Listing tickets assigned to these owners (owner &#x3D; 100 means owner is not assigned)
    # @option opts [Array<Integer>] :not_owner Listing tickets NOT assigned to these owners (owner &#x3D; 100 means owner is not assigned)
    # @option opts [Array<Integer>] :reporter Listing tickets reported by these users (report &#x3D; 100 means reported by non login user)
    # @option opts [Array<Integer>] :not_reporter Listing tickets reported by these users (report &#x3D; 100 means reported by non login user)
    # @option opts [String] :text Listing tickets title or description or comment include the text
    # @return [Array<ProjectTicketItem>]
    def list_project_ticket(id_or_name, opts = {})
      data, _status_code, _headers = list_project_ticket_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # List project ticket order by submit date descending
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :status Tickets are assigned to these type_ids
    # @option opts [Array<Integer>] :type_id Listing tickets are assigned to these type_ids
    # @option opts [Array<Integer>] :not_type_id Listing tickets are NOT assigned to these type_ids
    # @option opts [Array<Integer>] :component_id Listing tickets are assigned to these component_ids (If you want to indicate component is not assigned, please use component_id &#x3D; 0)
    # @option opts [Array<Integer>] :not_component_id Listing tickets are NOT assigned to these component_ids (If you want to indicate component is not assigned, please use component_id &#x3D; 0)
    # @option opts [Array<Integer>] :milestone_id Listing tickets are assigned to these milestone_ids (If you want to indicate milestone is not assigned, please use milestone_id &#x3D; 0)
    # @option opts [Array<Integer>] :not_milestone_id Listing tickets are NOT assigned to these milestone_ids (milestone_id &#x3D; 0 means milestone not assigned)
    # @option opts [Integer] :max_priority Listing equal or lower priority tickets
    # @option opts [Integer] :min_priority Listing equal or higher priority tickets
    # @option opts [Integer] :priority Listing tickets have this priority
    # @option opts [Integer] :max_severity Listing equal or lower severity tickets
    # @option opts [Integer] :min_severity Listing equal or higher severity tickets
    # @option opts [Integer] :severity Listing tickets have this severity
    # @option opts [Array<Integer>] :owner Listing tickets assigned to these owners (owner &#x3D; 100 means owner is not assigned)
    # @option opts [Array<Integer>] :not_owner Listing tickets NOT assigned to these owners (owner &#x3D; 100 means owner is not assigned)
    # @option opts [Array<Integer>] :reporter Listing tickets reported by these users (report &#x3D; 100 means reported by non login user)
    # @option opts [Array<Integer>] :not_reporter Listing tickets reported by these users (report &#x3D; 100 means reported by non login user)
    # @option opts [String] :text Listing tickets title or description or comment include the text
    # @return [Array<(Array<ProjectTicketItem>, Fixnum, Hash)>] Array<ProjectTicketItem> data, response status code and response headers
    def list_project_ticket_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.list_project_ticket ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.list_project_ticket" if id_or_name.nil?
      if opts[:'status'] && ![].include?(opts[:'status'])
        fail ArgumentError, 'invalid value for "status", must be one of '
      end
      if opts[:'max_priority'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"max_priority"]" when calling ProjectTicketApi.list_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'max_priority'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"max_priority"]" when calling ProjectTicketApi.list_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'min_priority'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"min_priority"]" when calling ProjectTicketApi.list_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'min_priority'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"min_priority"]" when calling ProjectTicketApi.list_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'priority'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"priority"]" when calling ProjectTicketApi.list_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'priority'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"priority"]" when calling ProjectTicketApi.list_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'max_severity'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"max_severity"]" when calling ProjectTicketApi.list_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'max_severity'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"max_severity"]" when calling ProjectTicketApi.list_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'min_severity'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"min_severity"]" when calling ProjectTicketApi.list_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'min_severity'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"min_severity"]" when calling ProjectTicketApi.list_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'severity'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"severity"]" when calling ProjectTicketApi.list_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'severity'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"severity"]" when calling ProjectTicketApi.list_project_ticket, must be greater than or equal to 1.0.'
      end

      # resource path
      local_var_path = "/project/{id_or_name}/ticket".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}
      query_params[:'status'] = @api_client.build_collection_param(opts[:'status'], :csv) if !opts[:'status'].nil?
      query_params[:'type_id'] = @api_client.build_collection_param(opts[:'type_id'], :csv) if !opts[:'type_id'].nil?
      query_params[:'not_type_id'] = @api_client.build_collection_param(opts[:'not_type_id'], :csv) if !opts[:'not_type_id'].nil?
      query_params[:'component_id'] = @api_client.build_collection_param(opts[:'component_id'], :csv) if !opts[:'component_id'].nil?
      query_params[:'not_component_id'] = @api_client.build_collection_param(opts[:'not_component_id'], :csv) if !opts[:'not_component_id'].nil?
      query_params[:'milestone_id'] = @api_client.build_collection_param(opts[:'milestone_id'], :csv) if !opts[:'milestone_id'].nil?
      query_params[:'not_milestone_id'] = @api_client.build_collection_param(opts[:'not_milestone_id'], :csv) if !opts[:'not_milestone_id'].nil?
      query_params[:'max_priority'] = opts[:'max_priority'] if !opts[:'max_priority'].nil?
      query_params[:'min_priority'] = opts[:'min_priority'] if !opts[:'min_priority'].nil?
      query_params[:'priority'] = opts[:'priority'] if !opts[:'priority'].nil?
      query_params[:'max_severity'] = opts[:'max_severity'] if !opts[:'max_severity'].nil?
      query_params[:'min_severity'] = opts[:'min_severity'] if !opts[:'min_severity'].nil?
      query_params[:'severity'] = opts[:'severity'] if !opts[:'severity'].nil?
      query_params[:'owner'] = @api_client.build_collection_param(opts[:'owner'], :csv) if !opts[:'owner'].nil?
      query_params[:'not_owner'] = @api_client.build_collection_param(opts[:'not_owner'], :csv) if !opts[:'not_owner'].nil?
      query_params[:'reporter'] = @api_client.build_collection_param(opts[:'reporter'], :csv) if !opts[:'reporter'].nil?
      query_params[:'not_reporter'] = @api_client.build_collection_param(opts[:'not_reporter'], :csv) if !opts[:'not_reporter'].nil?
      query_params[:'text'] = opts[:'text'] if !opts[:'text'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectTicketItem>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#list_project_ticket\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket comment list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param [Hash] opts the optional parameters
    # @return [Array<ProjectTicketComment>]
    def list_project_ticket_comment(id_or_name, ticket_id, opts = {})
      data, _status_code, _headers = list_project_ticket_comment_with_http_info(id_or_name, ticket_id, opts)
      return data
    end

    # 
    # Get project ticket comment list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ProjectTicketComment>, Fixnum, Hash)>] Array<ProjectTicketComment> data, response status code and response headers
    def list_project_ticket_comment_with_http_info(id_or_name, ticket_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.list_project_ticket_comment ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.list_project_ticket_comment" if id_or_name.nil?
      # verify the required parameter 'ticket_id' is set
      fail ArgumentError, "Missing the required parameter 'ticket_id' when calling ProjectTicketApi.list_project_ticket_comment" if ticket_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/{ticket_id}/comment".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'ticket_id' + '}', ticket_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectTicketComment>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#list_project_ticket_comment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket component list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<ProjectTicketComponent>]
    def list_project_ticket_component(id_or_name, opts = {})
      data, _status_code, _headers = list_project_ticket_component_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project ticket component list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ProjectTicketComponent>, Fixnum, Hash)>] Array<ProjectTicketComponent> data, response status code and response headers
    def list_project_ticket_component_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.list_project_ticket_component ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.list_project_ticket_component" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/component".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectTicketComponent>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#list_project_ticket_component\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket milestone list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<ProjectTicketMilestone>]
    def list_project_ticket_milestone(id_or_name, opts = {})
      data, _status_code, _headers = list_project_ticket_milestone_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project ticket milestone list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ProjectTicketMilestone>, Fixnum, Hash)>] Array<ProjectTicketMilestone> data, response status code and response headers
    def list_project_ticket_milestone_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.list_project_ticket_milestone ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.list_project_ticket_milestone" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/milestone".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectTicketMilestone>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#list_project_ticket_milestone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket type list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<ProjectTicketType>]
    def list_project_ticket_type(id_or_name, opts = {})
      data, _status_code, _headers = list_project_ticket_type_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project ticket type list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ProjectTicketType>, Fixnum, Hash)>] Array<ProjectTicketType> data, response status code and response headers
    def list_project_ticket_type_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.list_project_ticket_type ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.list_project_ticket_type" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectTicketType>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#list_project_ticket_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket type instructions
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketTypeInstructions]
    def list_project_ticket_type_instruction(id_or_name, type_id, opts = {})
      data, _status_code, _headers = list_project_ticket_type_instruction_with_http_info(id_or_name, type_id, opts)
      return data
    end

    # 
    # Get project ticket type instructions
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketTypeInstructions, Fixnum, Hash)>] ProjectTicketTypeInstructions data, response status code and response headers
    def list_project_ticket_type_instruction_with_http_info(id_or_name, type_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.list_project_ticket_type_instruction ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.list_project_ticket_type_instruction" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectTicketApi.list_project_ticket_type_instruction" if type_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}/instruction".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketTypeInstructions')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#list_project_ticket_type_instruction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket admin preferences.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketPrefs]
    def show_project_ticket_adminprefs(id_or_name, opts = {})
      data, _status_code, _headers = show_project_ticket_adminprefs_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project ticket admin preferences.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketPrefs, Fixnum, Hash)>] ProjectTicketPrefs data, response status code and response headers
    def show_project_ticket_adminprefs_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.show_project_ticket_adminprefs ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.show_project_ticket_adminprefs" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/admin".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketPrefs')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#show_project_ticket_adminprefs\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket comment spscified project.
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param comment_id numeric project ticket comment id
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketComment]
    def show_project_ticket_comment(id_or_name, ticket_id, comment_id, opts = {})
      data, _status_code, _headers = show_project_ticket_comment_with_http_info(id_or_name, ticket_id, comment_id, opts)
      return data
    end

    # 
    # Get project ticket comment spscified project.
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param comment_id numeric project ticket comment id
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketComment, Fixnum, Hash)>] ProjectTicketComment data, response status code and response headers
    def show_project_ticket_comment_with_http_info(id_or_name, ticket_id, comment_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.show_project_ticket_comment ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.show_project_ticket_comment" if id_or_name.nil?
      # verify the required parameter 'ticket_id' is set
      fail ArgumentError, "Missing the required parameter 'ticket_id' when calling ProjectTicketApi.show_project_ticket_comment" if ticket_id.nil?
      # verify the required parameter 'comment_id' is set
      fail ArgumentError, "Missing the required parameter 'comment_id' when calling ProjectTicketApi.show_project_ticket_comment" if comment_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/{ticket_id}/comment/{comment_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'ticket_id' + '}', ticket_id.to_s).sub('{' + 'comment_id' + '}', comment_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketComment')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#show_project_ticket_comment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project ticket
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Project ticket name (title)
    # @option opts [String] :description Project ticket description details
    # @option opts [Integer] :type_id numeric project ticket type id
    # @option opts [Integer] :milestone_id numeric project ticket milestone id
    # @option opts [Integer] :component_id numeric project ticket component id
    # @option opts [Integer] :priority project ticket priority (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :severity project ticket severity (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :owner numeric project ticket owner user id
    # @option opts [String] :resolution project ticket resolution text
    # @option opts [String] :status project ticket status (open or close)
    # @return [ProjectTicketItem]
    def update_project_ticket(id_or_name, ticket_id, opts = {})
      data, _status_code, _headers = update_project_ticket_with_http_info(id_or_name, ticket_id, opts)
      return data
    end

    # 
    # Update project ticket
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Project ticket name (title)
    # @option opts [String] :description Project ticket description details
    # @option opts [Integer] :type_id numeric project ticket type id
    # @option opts [Integer] :milestone_id numeric project ticket milestone id
    # @option opts [Integer] :component_id numeric project ticket component id
    # @option opts [Integer] :priority project ticket priority (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :severity project ticket severity (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :owner numeric project ticket owner user id
    # @option opts [String] :resolution project ticket resolution text
    # @option opts [String] :status project ticket status (open or close)
    # @return [Array<(ProjectTicketItem, Fixnum, Hash)>] ProjectTicketItem data, response status code and response headers
    def update_project_ticket_with_http_info(id_or_name, ticket_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.update_project_ticket ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.update_project_ticket" if id_or_name.nil?
      # verify the required parameter 'ticket_id' is set
      fail ArgumentError, "Missing the required parameter 'ticket_id' when calling ProjectTicketApi.update_project_ticket" if ticket_id.nil?
      if opts[:'priority'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"priority"]" when calling ProjectTicketApi.update_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'priority'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"priority"]" when calling ProjectTicketApi.update_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'severity'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"severity"]" when calling ProjectTicketApi.update_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'severity'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"severity"]" when calling ProjectTicketApi.update_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'owner'] < 101.0
        fail ArgumentError, 'invalid value for "opts[:"owner"]" when calling ProjectTicketApi.update_project_ticket, must be greater than or equal to 101.0.'
      end

      if opts[:'resolution'] && !['Fixed', 'Invalid', 'Wont Fix', 'Later', 'Remind', 'Works For Me', 'None', 'Duplicate', 'Accepted', 'Out of Date', 'Postponed', 'Rejected'].include?(opts[:'resolution'])
        fail ArgumentError, 'invalid value for "resolution", must be one of Fixed, Invalid, Wont Fix, Later, Remind, Works For Me, None, Duplicate, Accepted, Out of Date, Postponed, Rejected'
      end
      if opts[:'status'] && !['close', 'reopen'].include?(opts[:'status'])
        fail ArgumentError, 'invalid value for "status", must be one of close, reopen'
      end
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/{ticket_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'ticket_id' + '}', ticket_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = opts[:'name'] if !opts[:'name'].nil?
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["type_id"] = opts[:'type_id'] if !opts[:'type_id'].nil?
      form_params["milestone_id"] = opts[:'milestone_id'] if !opts[:'milestone_id'].nil?
      form_params["component_id"] = opts[:'component_id'] if !opts[:'component_id'].nil?
      form_params["priority"] = opts[:'priority'] if !opts[:'priority'].nil?
      form_params["severity"] = opts[:'severity'] if !opts[:'severity'].nil?
      form_params["owner"] = opts[:'owner'] if !opts[:'owner'].nil?
      form_params["resolution"] = opts[:'resolution'] if !opts[:'resolution'].nil?
      form_params["status"] = opts[:'status'] if !opts[:'status'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketItem')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#update_project_ticket\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project ticket admin preferences.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :allow_anonymouse Non login user allows to post new ticket/comment
    # @option opts [String] :frs_autosync Componet File release autosync type &#39;Disabled&#39;, &#39;Package&#39;, &#39;Release&#39;, &#39;Package and Release&#39;
    # @option opts [String] :mailsend_type Ticket update mail destination type &#39;None&#39;, &#39;Ticket Technician&#39;, &#39;Ticket Administrator&#39;, &#39;Ticket Administrator and Technician&#39;, &#39;All project members&#39;, &#39;Mailing List&#39;
    # @option opts [Integer] :mailing_list_id Ticket update mail destination mail list id (it is only used when mailsend_type is mailing list)
    # @option opts [String] :mail_lang Ticket update mail language
    # @return [ProjectTicketPrefs]
    def update_project_ticket_adminprefs(id_or_name, opts = {})
      data, _status_code, _headers = update_project_ticket_adminprefs_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Update project ticket admin preferences.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :allow_anonymouse Non login user allows to post new ticket/comment
    # @option opts [String] :frs_autosync Componet File release autosync type &#39;Disabled&#39;, &#39;Package&#39;, &#39;Release&#39;, &#39;Package and Release&#39;
    # @option opts [String] :mailsend_type Ticket update mail destination type &#39;None&#39;, &#39;Ticket Technician&#39;, &#39;Ticket Administrator&#39;, &#39;Ticket Administrator and Technician&#39;, &#39;All project members&#39;, &#39;Mailing List&#39;
    # @option opts [Integer] :mailing_list_id Ticket update mail destination mail list id (it is only used when mailsend_type is mailing list)
    # @option opts [String] :mail_lang Ticket update mail language
    # @return [Array<(ProjectTicketPrefs, Fixnum, Hash)>] ProjectTicketPrefs data, response status code and response headers
    def update_project_ticket_adminprefs_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.update_project_ticket_adminprefs ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.update_project_ticket_adminprefs" if id_or_name.nil?
      if opts[:'frs_autosync'] && !['Disabled', 'Package', 'Release', 'Package and Release'].include?(opts[:'frs_autosync'])
        fail ArgumentError, 'invalid value for "frs_autosync", must be one of Disabled, Package, Release, Package and Release'
      end
      if opts[:'mailsend_type'] && !['None', 'Ticket Technician', 'Ticket Administrator', 'Ticket Administrator and Technician', 'All project members', 'Mailing List'].include?(opts[:'mailsend_type'])
        fail ArgumentError, 'invalid value for "mailsend_type", must be one of None, Ticket Technician, Ticket Administrator, Ticket Administrator and Technician, All project members, Mailing List'
      end
      if opts[:'mail_lang'] && !['English', 'Japanese'].include?(opts[:'mail_lang'])
        fail ArgumentError, 'invalid value for "mail_lang", must be one of English, Japanese'
      end
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/admin".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["allow_anonymouse"] = opts[:'allow_anonymouse'] if !opts[:'allow_anonymouse'].nil?
      form_params["frs_autosync"] = opts[:'frs_autosync'] if !opts[:'frs_autosync'].nil?
      form_params["mailsend_type"] = opts[:'mailsend_type'] if !opts[:'mailsend_type'].nil?
      form_params["mailing_list_id"] = opts[:'mailing_list_id'] if !opts[:'mailing_list_id'].nil?
      form_params["mail_lang"] = opts[:'mail_lang'] if !opts[:'mail_lang'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketPrefs')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#update_project_ticket_adminprefs\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project ticket component
    # @param id_or_name numeric project id or project name
    # @param component_id numeric project ticket component id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Ticket component name
    # @option opts [String] :description Ticket component description
    # @option opts [Integer] :owner Ticket componet owner user_id
    # @option opts [BOOLEAN] :active Ticket componet will be shown the component select list when this parameter is true
    # @return [ProjectTicketComponent]
    def update_project_ticket_component(id_or_name, component_id, opts = {})
      data, _status_code, _headers = update_project_ticket_component_with_http_info(id_or_name, component_id, opts)
      return data
    end

    # 
    # Update project ticket component
    # @param id_or_name numeric project id or project name
    # @param component_id numeric project ticket component id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Ticket component name
    # @option opts [String] :description Ticket component description
    # @option opts [Integer] :owner Ticket componet owner user_id
    # @option opts [BOOLEAN] :active Ticket componet will be shown the component select list when this parameter is true
    # @return [Array<(ProjectTicketComponent, Fixnum, Hash)>] ProjectTicketComponent data, response status code and response headers
    def update_project_ticket_component_with_http_info(id_or_name, component_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.update_project_ticket_component ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.update_project_ticket_component" if id_or_name.nil?
      # verify the required parameter 'component_id' is set
      fail ArgumentError, "Missing the required parameter 'component_id' when calling ProjectTicketApi.update_project_ticket_component" if component_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/component/{component_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'component_id' + '}', component_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = opts[:'name'] if !opts[:'name'].nil?
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["owner"] = opts[:'owner'] if !opts[:'owner'].nil?
      form_params["active"] = opts[:'active'] if !opts[:'active'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketComponent')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#update_project_ticket_component\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project ticket milestone
    # @param id_or_name numeric project id or project name
    # @param milestone_id numeric project ticket milestone id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Ticket milestone name
    # @option opts [String] :description Ticket milestone description
    # @option opts [DateTime] :start Ticket milestone start date
    # @option opts [DateTime] :_end Ticket milestone due date
    # @option opts [String] :force_status If you want to force close the milestone set to &#39;close&#39; or reopen it set to &#39;reopen&#39;
    # @return [ProjectTicketComponent]
    def update_project_ticket_milestone(id_or_name, milestone_id, opts = {})
      data, _status_code, _headers = update_project_ticket_milestone_with_http_info(id_or_name, milestone_id, opts)
      return data
    end

    # 
    # Update project ticket milestone
    # @param id_or_name numeric project id or project name
    # @param milestone_id numeric project ticket milestone id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Ticket milestone name
    # @option opts [String] :description Ticket milestone description
    # @option opts [DateTime] :start Ticket milestone start date
    # @option opts [DateTime] :_end Ticket milestone due date
    # @option opts [String] :force_status If you want to force close the milestone set to &#39;close&#39; or reopen it set to &#39;reopen&#39;
    # @return [Array<(ProjectTicketComponent, Fixnum, Hash)>] ProjectTicketComponent data, response status code and response headers
    def update_project_ticket_milestone_with_http_info(id_or_name, milestone_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.update_project_ticket_milestone ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.update_project_ticket_milestone" if id_or_name.nil?
      # verify the required parameter 'milestone_id' is set
      fail ArgumentError, "Missing the required parameter 'milestone_id' when calling ProjectTicketApi.update_project_ticket_milestone" if milestone_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/milestone/{milestone_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'milestone_id' + '}', milestone_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = opts[:'name'] if !opts[:'name'].nil?
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["start"] = opts[:'start'] if !opts[:'start'].nil?
      form_params["end"] = opts[:'_end'] if !opts[:'_end'].nil?
      form_params["force_status"] = opts[:'force_status'] if !opts[:'force_status'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketComponent')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#update_project_ticket_milestone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project ticket type
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Ticket type name
    # @option opts [String] :description Ticket type description
    # @option opts [BOOLEAN] :is_public if set as false, this type will be shown to project members only.
    # @return [ProjectTicketType]
    def update_project_ticket_type(id_or_name, type_id, opts = {})
      data, _status_code, _headers = update_project_ticket_type_with_http_info(id_or_name, type_id, opts)
      return data
    end

    # 
    # Update project ticket type
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Ticket type name
    # @option opts [String] :description Ticket type description
    # @option opts [BOOLEAN] :is_public if set as false, this type will be shown to project members only.
    # @return [Array<(ProjectTicketType, Fixnum, Hash)>] ProjectTicketType data, response status code and response headers
    def update_project_ticket_type_with_http_info(id_or_name, type_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectTicketApi.update_project_ticket_type ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectTicketApi.update_project_ticket_type" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectTicketApi.update_project_ticket_type" if type_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = opts[:'name'] if !opts[:'name'].nil?
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["is_public"] = opts[:'is_public'] if !opts[:'is_public'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketType')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectTicketApi#update_project_ticket_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
