=begin
#OSDN REST API v0 beta

#OSDN REST API. Currently this API is experimental release. Pelase refer documentation on https://osdn.net/projects/osdn-codes/wiki/APIGuide and you can get client libraries from https://osdn.net/projects/osdn-codes/releases/p14859 . 

OpenAPI spec version: 0.0.20171120
Contact: admin@osdn.net
Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module OSDNClient
  class UserApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # Get user profile. 
    # @param id_or_name numeric user id or user name
    # @param [Hash] opts the optional parameters
    # @return [User]
    def get_user(id_or_name, opts = {})
      data, _status_code, _headers = get_user_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get user profile. 
    # @param id_or_name numeric user id or user name
    # @param [Hash] opts the optional parameters
    # @return [Array<(User, Fixnum, Hash)>] User data, response status code and response headers
    def get_user_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserApi.get_user ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling UserApi.get_user" if id_or_name.nil?
      # resource path
      local_var_path = "/user/{id_or_name}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'User')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#get_user\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # get user monthly stats.
    # @param id_or_name numeric user id or user name
    # @param [Hash] opts the optional parameters
    # @return [Array<History>]
    def get_user_history(id_or_name, opts = {})
      data, _status_code, _headers = get_user_history_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # get user monthly stats.
    # @param id_or_name numeric user id or user name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<History>, Fixnum, Hash)>] Array<History> data, response status code and response headers
    def get_user_history_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserApi.get_user_history ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling UserApi.get_user_history" if id_or_name.nil?
      # resource path
      local_var_path = "/user/{id_or_name}/history".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<History>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#get_user_history\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # get user daily stats.
    # @param id_or_name numeric user id or user name
    # @param [Hash] opts the optional parameters
    # @return [Array<UserStats>]
    def get_user_stats_daily(id_or_name, opts = {})
      data, _status_code, _headers = get_user_stats_daily_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # get user daily stats.
    # @param id_or_name numeric user id or user name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<UserStats>, Fixnum, Hash)>] Array<UserStats> data, response status code and response headers
    def get_user_stats_daily_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserApi.get_user_stats_daily ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling UserApi.get_user_stats_daily" if id_or_name.nil?
      # resource path
      local_var_path = "/user/{id_or_name}/stats/daily".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<UserStats>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#get_user_stats_daily\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # get user monthly stats.
    # @param id_or_name numeric user id or user name
    # @param [Hash] opts the optional parameters
    # @return [Array<UserStats>]
    def get_user_stats_monthly(id_or_name, opts = {})
      data, _status_code, _headers = get_user_stats_monthly_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # get user monthly stats.
    # @param id_or_name numeric user id or user name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<UserStats>, Fixnum, Hash)>] Array<UserStats> data, response status code and response headers
    def get_user_stats_monthly_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserApi.get_user_stats_monthly ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling UserApi.get_user_stats_monthly" if id_or_name.nil?
      # resource path
      local_var_path = "/user/{id_or_name}/stats/monthly".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<UserStats>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#get_user_stats_monthly\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update user icon, the image will be resized to 12x12 automatically. 
    # @param id_or_name numeric user id or user name
    # @param image The image data to update, you need to send with multipart/form-data.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def update_user_icon(id_or_name, image, opts = {})
      update_user_icon_with_http_info(id_or_name, image, opts)
      return nil
    end

    # 
    # Update user icon, the image will be resized to 12x12 automatically. 
    # @param id_or_name numeric user id or user name
    # @param image The image data to update, you need to send with multipart/form-data.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def update_user_icon_with_http_info(id_or_name, image, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserApi.update_user_icon ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling UserApi.update_user_icon" if id_or_name.nil?
      # verify the required parameter 'image' is set
      fail ArgumentError, "Missing the required parameter 'image' when calling UserApi.update_user_icon" if image.nil?
      # resource path
      local_var_path = "/user/{id_or_name}/icon".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['multipart/form-data']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["image"] = image

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#update_user_icon\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update user profile photo. 
    # @param id_or_name numeric user id or user name
    # @param image The image data to update, you need to send with multipart/form-data.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def update_user_photo(id_or_name, image, opts = {})
      update_user_photo_with_http_info(id_or_name, image, opts)
      return nil
    end

    # 
    # Update user profile photo. 
    # @param id_or_name numeric user id or user name
    # @param image The image data to update, you need to send with multipart/form-data.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def update_user_photo_with_http_info(id_or_name, image, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserApi.update_user_photo ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling UserApi.update_user_photo" if id_or_name.nil?
      # verify the required parameter 'image' is set
      fail ArgumentError, "Missing the required parameter 'image' when calling UserApi.update_user_photo" if image.nil?
      # resource path
      local_var_path = "/user/{id_or_name}/photo".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['multipart/form-data']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["image"] = image

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#update_user_photo\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
