=begin
#OSDN REST API v0 beta

#OSDN REST API. Currently this API is experimental release. Pelase refer documentation on https://osdn.net/projects/osdn-codes/wiki/APIGuide and you can get client libraries from https://osdn.net/projects/osdn-codes/releases/p14859 . 

OpenAPI spec version: 0.0.20171120
Contact: admin@osdn.net
Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module OSDNClient
  class ProjectApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # 
    # @param title news title
    # @param body news body in OSDN Wiki format.
    # @param group_id group_id the news created in
    # @param [Hash] opts the optional parameters
    # @return [String]
    def create_news(title, body, group_id, opts = {})
      data, _status_code, _headers = create_news_with_http_info(title, body, group_id, opts)
      return data
    end

    # 
    # 
    # @param title news title
    # @param body news body in OSDN Wiki format.
    # @param group_id group_id the news created in
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def create_news_with_http_info(title, body, group_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_news ..."
      end
      # verify the required parameter 'title' is set
      fail ArgumentError, "Missing the required parameter 'title' when calling ProjectApi.create_news" if title.nil?
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling ProjectApi.create_news" if body.nil?
      # verify the required parameter 'group_id' is set
      fail ArgumentError, "Missing the required parameter 'group_id' when calling ProjectApi.create_news" if group_id.nil?
      # resource path
      local_var_path = "/news".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'group_id'] = group_id

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["title"] = title
      form_params["body"] = body

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_news\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param id_or_name numeric project id or project name
    # @param title news title
    # @param body news body in OSDN Wiki format.
    # @param [Hash] opts the optional parameters
    # @return [String]
    def create_news_0(id_or_name, title, body, opts = {})
      data, _status_code, _headers = create_news_0_with_http_info(id_or_name, title, body, opts)
      return data
    end

    # 
    # 
    # @param id_or_name numeric project id or project name
    # @param title news title
    # @param body news body in OSDN Wiki format.
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def create_news_0_with_http_info(id_or_name, title, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_news_0 ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_news_0" if id_or_name.nil?
      # verify the required parameter 'title' is set
      fail ArgumentError, "Missing the required parameter 'title' when calling ProjectApi.create_news_0" if title.nil?
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling ProjectApi.create_news_0" if body.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/news".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["title"] = title
      form_params["body"] = body

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_news_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create a package.
    # @param id_or_name numeric project id or project name
    # @param name package name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [Package]
    def create_package(id_or_name, name, opts = {})
      data, _status_code, _headers = create_package_with_http_info(id_or_name, name, opts)
      return data
    end

    # 
    # Create a package.
    # @param id_or_name numeric project id or project name
    # @param name package name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [Array<(Package, Fixnum, Hash)>] Package data, response status code and response headers
    def create_package_with_http_info(id_or_name, name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_package ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_package" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectApi.create_package" if name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["visibility"] = opts[:'visibility'] if !opts[:'visibility'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Package')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_package\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create a new bzr repository
    # @param id_or_name numeric project id or project name
    # @param name 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :description 
    # @return [ProjectBzr]
    def create_project_bzr(id_or_name, name, opts = {})
      data, _status_code, _headers = create_project_bzr_with_http_info(id_or_name, name, opts)
      return data
    end

    # 
    # Create a new bzr repository
    # @param id_or_name numeric project id or project name
    # @param name 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :description 
    # @return [Array<(ProjectBzr, Fixnum, Hash)>] ProjectBzr data, response status code and response headers
    def create_project_bzr_with_http_info(id_or_name, name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_project_bzr ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_project_bzr" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectApi.create_project_bzr" if name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/bzr".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectBzr')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_project_bzr\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create a new git repository
    # @param id_or_name numeric project id or project name
    # @param name 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :description 
    # @option opts [BOOLEAN] :mail_enabled 
    # @option opts [String] :mail_recipients 
    # @option opts [BOOLEAN] :allow_non_fast_forward 
    # @option opts [String] :default_branch 
    # @return [ProjectGit]
    def create_project_git(id_or_name, name, opts = {})
      data, _status_code, _headers = create_project_git_with_http_info(id_or_name, name, opts)
      return data
    end

    # 
    # Create a new git repository
    # @param id_or_name numeric project id or project name
    # @param name 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :description 
    # @option opts [BOOLEAN] :mail_enabled 
    # @option opts [String] :mail_recipients 
    # @option opts [BOOLEAN] :allow_non_fast_forward 
    # @option opts [String] :default_branch 
    # @return [Array<(ProjectGit, Fixnum, Hash)>] ProjectGit data, response status code and response headers
    def create_project_git_with_http_info(id_or_name, name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_project_git ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_project_git" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectApi.create_project_git" if name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/git".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["mail_enabled"] = opts[:'mail_enabled'] if !opts[:'mail_enabled'].nil?
      form_params["mail_recipients"] = opts[:'mail_recipients'] if !opts[:'mail_recipients'].nil?
      form_params["allow_non_fast_forward"] = opts[:'allow_non_fast_forward'] if !opts[:'allow_non_fast_forward'].nil?
      form_params["default_branch"] = opts[:'default_branch'] if !opts[:'default_branch'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectGit')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_project_git\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create a new hook for project git repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param target_url 
    # @param [Hash] opts the optional parameters
    # @return [ScmHook]
    def create_project_git_hook(id_or_name, repo_id, target_url, opts = {})
      data, _status_code, _headers = create_project_git_hook_with_http_info(id_or_name, repo_id, target_url, opts)
      return data
    end

    # 
    # Create a new hook for project git repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param target_url 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ScmHook, Fixnum, Hash)>] ScmHook data, response status code and response headers
    def create_project_git_hook_with_http_info(id_or_name, repo_id, target_url, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_project_git_hook ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_project_git_hook" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.create_project_git_hook" if repo_id.nil?
      # verify the required parameter 'target_url' is set
      fail ArgumentError, "Missing the required parameter 'target_url' when calling ProjectApi.create_project_git_hook" if target_url.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/git/{repo_id}/hooks".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["target_url"] = target_url

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ScmHook')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_project_git_hook\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create a new hg repository
    # @param id_or_name numeric project id or project name
    # @param name 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :description 
    # @option opts [String] :mail_recipients 
    # @return [ProjectHg]
    def create_project_hg(id_or_name, name, opts = {})
      data, _status_code, _headers = create_project_hg_with_http_info(id_or_name, name, opts)
      return data
    end

    # 
    # Create a new hg repository
    # @param id_or_name numeric project id or project name
    # @param name 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :description 
    # @option opts [String] :mail_recipients 
    # @return [Array<(ProjectHg, Fixnum, Hash)>] ProjectHg data, response status code and response headers
    def create_project_hg_with_http_info(id_or_name, name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_project_hg ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_project_hg" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectApi.create_project_hg" if name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/hg".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["mail_recipients"] = opts[:'mail_recipients'] if !opts[:'mail_recipients'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectHg')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_project_hg\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create project profile for the language
    # @param id_or_name numeric project id or project name
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param display_name Project display name
    # @param description Project description
    # @param [Hash] opts the optional parameters
    # @return [GroupProfile]
    def create_project_profile(id_or_name, language_code, display_name, description, opts = {})
      data, _status_code, _headers = create_project_profile_with_http_info(id_or_name, language_code, display_name, description, opts)
      return data
    end

    # 
    # Create project profile for the language
    # @param id_or_name numeric project id or project name
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param display_name Project display name
    # @param description Project description
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupProfile, Fixnum, Hash)>] GroupProfile data, response status code and response headers
    def create_project_profile_with_http_info(id_or_name, language_code, display_name, description, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_project_profile ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_project_profile" if id_or_name.nil?
      # verify the required parameter 'language_code' is set
      fail ArgumentError, "Missing the required parameter 'language_code' when calling ProjectApi.create_project_profile" if language_code.nil?
      # verify enum value
      unless ['de', 'en', 'es', 'fr', 'ja', 'ko', 'pt', 'zh', 'zh-tw'].include?(language_code)
        fail ArgumentError, "invalid value for 'language_code', must be one of de, en, es, fr, ja, ko, pt, zh, zh-tw"
      end
      # verify the required parameter 'display_name' is set
      fail ArgumentError, "Missing the required parameter 'display_name' when calling ProjectApi.create_project_profile" if display_name.nil?
      # verify the required parameter 'description' is set
      fail ArgumentError, "Missing the required parameter 'description' when calling ProjectApi.create_project_profile" if description.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/admin/profile".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["language_code"] = language_code
      form_params["display_name"] = display_name
      form_params["description"] = description

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GroupProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_project_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create project ticket
    # @param id_or_name numeric project id or project name
    # @param name Project ticket name (title)
    # @param description Project ticket description details
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :milestone_id numeric project ticket milestone id
    # @option opts [Integer] :component_id numeric project ticket component id
    # @option opts [Integer] :priority project ticket priority (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :severity project ticket severity (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :owner numeric project ticket owner user id
    # @return [ProjectTicketItem]
    def create_project_ticket(id_or_name, name, description, type_id, opts = {})
      data, _status_code, _headers = create_project_ticket_with_http_info(id_or_name, name, description, type_id, opts)
      return data
    end

    # 
    # Create project ticket
    # @param id_or_name numeric project id or project name
    # @param name Project ticket name (title)
    # @param description Project ticket description details
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :milestone_id numeric project ticket milestone id
    # @option opts [Integer] :component_id numeric project ticket component id
    # @option opts [Integer] :priority project ticket priority (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :severity project ticket severity (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :owner numeric project ticket owner user id
    # @return [Array<(ProjectTicketItem, Fixnum, Hash)>] ProjectTicketItem data, response status code and response headers
    def create_project_ticket_with_http_info(id_or_name, name, description, type_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_project_ticket ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_project_ticket" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectApi.create_project_ticket" if name.nil?
      # verify the required parameter 'description' is set
      fail ArgumentError, "Missing the required parameter 'description' when calling ProjectApi.create_project_ticket" if description.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectApi.create_project_ticket" if type_id.nil?
      if opts[:'priority'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"priority"]" when calling ProjectApi.create_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'priority'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"priority"]" when calling ProjectApi.create_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'severity'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"severity"]" when calling ProjectApi.create_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'severity'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"severity"]" when calling ProjectApi.create_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'owner'] < 101.0
        fail ArgumentError, 'invalid value for "opts[:"owner"]" when calling ProjectApi.create_project_ticket, must be greater than or equal to 101.0.'
      end

      # resource path
      local_var_path = "/project/{id_or_name}/ticket".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["description"] = description
      form_params["type_id"] = type_id
      form_params["milestone_id"] = opts[:'milestone_id'] if !opts[:'milestone_id'].nil?
      form_params["component_id"] = opts[:'component_id'] if !opts[:'component_id'].nil?
      form_params["priority"] = opts[:'priority'] if !opts[:'priority'].nil?
      form_params["severity"] = opts[:'severity'] if !opts[:'severity'].nil?
      form_params["owner"] = opts[:'owner'] if !opts[:'owner'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketItem')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_project_ticket\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create new project ticket comment of spscified project.
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param comment Ticket comment text
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketComment]
    def create_project_ticket_comment(id_or_name, ticket_id, comment, opts = {})
      data, _status_code, _headers = create_project_ticket_comment_with_http_info(id_or_name, ticket_id, comment, opts)
      return data
    end

    # 
    # Create new project ticket comment of spscified project.
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param comment Ticket comment text
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketComment, Fixnum, Hash)>] ProjectTicketComment data, response status code and response headers
    def create_project_ticket_comment_with_http_info(id_or_name, ticket_id, comment, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_project_ticket_comment ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_project_ticket_comment" if id_or_name.nil?
      # verify the required parameter 'ticket_id' is set
      fail ArgumentError, "Missing the required parameter 'ticket_id' when calling ProjectApi.create_project_ticket_comment" if ticket_id.nil?
      # verify the required parameter 'comment' is set
      fail ArgumentError, "Missing the required parameter 'comment' when calling ProjectApi.create_project_ticket_comment" if comment.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/{ticket_id}/comment".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'ticket_id' + '}', ticket_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["comment"] = comment

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketComment')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_project_ticket_comment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create new project ticket component of spscified project.
    # @param id_or_name numeric project id or project name
    # @param name Ticket component name
    # @param description Ticket component description
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :owner Ticket componet owner user_id
    # @option opts [BOOLEAN] :active Ticket componet will be shown the component select list when this parameter is true
    # @return [Array<ProjectTicketComponent>]
    def create_project_ticket_component(id_or_name, name, description, opts = {})
      data, _status_code, _headers = create_project_ticket_component_with_http_info(id_or_name, name, description, opts)
      return data
    end

    # 
    # Create new project ticket component of spscified project.
    # @param id_or_name numeric project id or project name
    # @param name Ticket component name
    # @param description Ticket component description
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :owner Ticket componet owner user_id
    # @option opts [BOOLEAN] :active Ticket componet will be shown the component select list when this parameter is true
    # @return [Array<(Array<ProjectTicketComponent>, Fixnum, Hash)>] Array<ProjectTicketComponent> data, response status code and response headers
    def create_project_ticket_component_with_http_info(id_or_name, name, description, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_project_ticket_component ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_project_ticket_component" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectApi.create_project_ticket_component" if name.nil?
      # verify the required parameter 'description' is set
      fail ArgumentError, "Missing the required parameter 'description' when calling ProjectApi.create_project_ticket_component" if description.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/component".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["description"] = description
      form_params["owner"] = opts[:'owner'] if !opts[:'owner'].nil?
      form_params["active"] = opts[:'active'] if !opts[:'active'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectTicketComponent>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_project_ticket_component\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create new project ticket milestone of spscified project.
    # @param id_or_name numeric project id or project name
    # @param name Ticket milestone name
    # @param description Ticket milestone description
    # @param [Hash] opts the optional parameters
    # @option opts [DateTime] :start Ticket milestone start date
    # @option opts [DateTime] :_end Ticket milestone due date
    # @return [ProjectTicketMilestone]
    def create_project_ticket_milestone(id_or_name, name, description, opts = {})
      data, _status_code, _headers = create_project_ticket_milestone_with_http_info(id_or_name, name, description, opts)
      return data
    end

    # 
    # Create new project ticket milestone of spscified project.
    # @param id_or_name numeric project id or project name
    # @param name Ticket milestone name
    # @param description Ticket milestone description
    # @param [Hash] opts the optional parameters
    # @option opts [DateTime] :start Ticket milestone start date
    # @option opts [DateTime] :_end Ticket milestone due date
    # @return [Array<(ProjectTicketMilestone, Fixnum, Hash)>] ProjectTicketMilestone data, response status code and response headers
    def create_project_ticket_milestone_with_http_info(id_or_name, name, description, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_project_ticket_milestone ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_project_ticket_milestone" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectApi.create_project_ticket_milestone" if name.nil?
      # verify the required parameter 'description' is set
      fail ArgumentError, "Missing the required parameter 'description' when calling ProjectApi.create_project_ticket_milestone" if description.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/milestone".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["description"] = description
      form_params["start"] = opts[:'start'] if !opts[:'start'].nil?
      form_params["end"] = opts[:'_end'] if !opts[:'_end'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketMilestone')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_project_ticket_milestone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create new project ticket type of spscified project.
    # @param id_or_name numeric project id or project name
    # @param name Ticket type name
    # @param description Ticket type description
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :is_public if set as false, this type will be shown to project members only.
    # @return [ProjectTicketType]
    def create_project_ticket_type(id_or_name, name, description, opts = {})
      data, _status_code, _headers = create_project_ticket_type_with_http_info(id_or_name, name, description, opts)
      return data
    end

    # 
    # Create new project ticket type of spscified project.
    # @param id_or_name numeric project id or project name
    # @param name Ticket type name
    # @param description Ticket type description
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :is_public if set as false, this type will be shown to project members only.
    # @return [Array<(ProjectTicketType, Fixnum, Hash)>] ProjectTicketType data, response status code and response headers
    def create_project_ticket_type_with_http_info(id_or_name, name, description, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_project_ticket_type ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_project_ticket_type" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectApi.create_project_ticket_type" if name.nil?
      # verify the required parameter 'description' is set
      fail ArgumentError, "Missing the required parameter 'description' when calling ProjectApi.create_project_ticket_type" if description.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["description"] = description
      form_params["is_public"] = opts[:'is_public'] if !opts[:'is_public'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketType')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_project_ticket_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create project ticket type instructions for the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param instruction Ticket submit instruction for the type
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketTypeInstructionPerLanguage]
    def create_project_ticket_type_instruction(id_or_name, type_id, language_code, instruction, opts = {})
      data, _status_code, _headers = create_project_ticket_type_instruction_with_http_info(id_or_name, type_id, language_code, instruction, opts)
      return data
    end

    # 
    # Create project ticket type instructions for the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param instruction Ticket submit instruction for the type
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketTypeInstructionPerLanguage, Fixnum, Hash)>] ProjectTicketTypeInstructionPerLanguage data, response status code and response headers
    def create_project_ticket_type_instruction_with_http_info(id_or_name, type_id, language_code, instruction, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_project_ticket_type_instruction ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_project_ticket_type_instruction" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectApi.create_project_ticket_type_instruction" if type_id.nil?
      # verify the required parameter 'language_code' is set
      fail ArgumentError, "Missing the required parameter 'language_code' when calling ProjectApi.create_project_ticket_type_instruction" if language_code.nil?
      # verify the required parameter 'instruction' is set
      fail ArgumentError, "Missing the required parameter 'instruction' when calling ProjectApi.create_project_ticket_type_instruction" if instruction.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}/instruction".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["language_code"] = language_code
      form_params["instruction"] = instruction

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketTypeInstructionPerLanguage')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_project_ticket_type_instruction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create new release in specified package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param name Release name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @option opts [DateTime] :time Release datetime. If you set future time, the release hide until specified time.
    # @option opts [String] :release_note Release note body text.
    # @option opts [String] :change_log Changelog body text.
    # @return [Release]
    def create_release(id_or_name, package_id, name, opts = {})
      data, _status_code, _headers = create_release_with_http_info(id_or_name, package_id, name, opts)
      return data
    end

    # 
    # Create new release in specified package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param name Release name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @option opts [DateTime] :time Release datetime. If you set future time, the release hide until specified time.
    # @option opts [String] :release_note Release note body text.
    # @option opts [String] :change_log Changelog body text.
    # @return [Array<(Release, Fixnum, Hash)>] Release data, response status code and response headers
    def create_release_with_http_info(id_or_name, package_id, name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_release ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_release" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.create_release" if package_id.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectApi.create_release" if name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["visibility"] = opts[:'visibility'] if !opts[:'visibility'].nil?
      form_params["time"] = opts[:'time'] if !opts[:'time'].nil?
      form_params["release_note"] = opts[:'release_note'] if !opts[:'release_note'].nil?
      form_params["change_log"] = opts[:'change_log'] if !opts[:'change_log'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Release')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_release\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create new file in target release.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file Upload file in \&quot;multipart/form-data\&quot;.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [RelFile]
    def create_release_file(id_or_name, package_id, release_id, file, opts = {})
      data, _status_code, _headers = create_release_file_with_http_info(id_or_name, package_id, release_id, file, opts)
      return data
    end

    # 
    # Create new file in target release.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file Upload file in \&quot;multipart/form-data\&quot;.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [Array<(RelFile, Fixnum, Hash)>] RelFile data, response status code and response headers
    def create_release_file_with_http_info(id_or_name, package_id, release_id, file, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_release_file ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_release_file" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.create_release_file" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.create_release_file" if release_id.nil?
      # verify the required parameter 'file' is set
      fail ArgumentError, "Missing the required parameter 'file' when calling ProjectApi.create_release_file" if file.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['multipart/form-data']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["file"] = file
      form_params["visibility"] = opts[:'visibility'] if !opts[:'visibility'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RelFile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_release_file\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_news(news_id, opts = {})
      delete_news_with_http_info(news_id, opts)
      return nil
    end

    # 
    # 
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_news_with_http_info(news_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_news ..."
      end
      # verify the required parameter 'news_id' is set
      fail ArgumentError, "Missing the required parameter 'news_id' when calling ProjectApi.delete_news" if news_id.nil?
      # resource path
      local_var_path = "/news/{news_id}".sub('{format}','json').sub('{' + 'news_id' + '}', news_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_news\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param id_or_name numeric project id or project name
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_news_0(id_or_name, news_id, opts = {})
      delete_news_0_with_http_info(id_or_name, news_id, opts)
      return nil
    end

    # 
    # 
    # @param id_or_name numeric project id or project name
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_news_0_with_http_info(id_or_name, news_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_news_0 ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_news_0" if id_or_name.nil?
      # verify the required parameter 'news_id' is set
      fail ArgumentError, "Missing the required parameter 'news_id' when calling ProjectApi.delete_news_0" if news_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/news/{news_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'news_id' + '}', news_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_news_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete taret package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_package(id_or_name, package_id, opts = {})
      delete_package_with_http_info(id_or_name, package_id, opts)
      return nil
    end

    # 
    # Delete taret package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_package_with_http_info(id_or_name, package_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_package ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_package" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.delete_package" if package_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_package\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete project homepage url
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_project_admin_projectweb(id_or_name, opts = {})
      delete_project_admin_projectweb_with_http_info(id_or_name, opts)
      return nil
    end

    # 
    # Delete project homepage url
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_project_admin_projectweb_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_project_admin_projectweb ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_project_admin_projectweb" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/admin/project_web".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_project_admin_projectweb\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete a Git repository hook
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param hook_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_project_git_hook(id_or_name, repo_id, hook_id, opts = {})
      delete_project_git_hook_with_http_info(id_or_name, repo_id, hook_id, opts)
      return nil
    end

    # 
    # Delete a Git repository hook
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param hook_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_project_git_hook_with_http_info(id_or_name, repo_id, hook_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_project_git_hook ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_project_git_hook" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.delete_project_git_hook" if repo_id.nil?
      # verify the required parameter 'hook_id' is set
      fail ArgumentError, "Missing the required parameter 'hook_id' when calling ProjectApi.delete_project_git_hook" if hook_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/git/{repo_id}/hooks/{hook_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s).sub('{' + 'hook_id' + '}', hook_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_project_git_hook\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete project profile for the language
    # @param id_or_name numeric project id or project name
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_project_profile(id_or_name, language_code, opts = {})
      delete_project_profile_with_http_info(id_or_name, language_code, opts)
      return nil
    end

    # 
    # Delete project profile for the language
    # @param id_or_name numeric project id or project name
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_project_profile_with_http_info(id_or_name, language_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_project_profile ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_project_profile" if id_or_name.nil?
      # verify the required parameter 'language_code' is set
      fail ArgumentError, "Missing the required parameter 'language_code' when calling ProjectApi.delete_project_profile" if language_code.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/admin/profile/{language_code}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'language_code' + '}', language_code.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_project_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete project ticket component
    # @param id_or_name numeric project id or project name
    # @param component_id numeric project ticket component id
    # @param migrate_to Tickets that assigned to delete target will be migrate to the ticket component_id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_project_ticket_component(id_or_name, component_id, migrate_to, opts = {})
      delete_project_ticket_component_with_http_info(id_or_name, component_id, migrate_to, opts)
      return nil
    end

    # 
    # Delete project ticket component
    # @param id_or_name numeric project id or project name
    # @param component_id numeric project ticket component id
    # @param migrate_to Tickets that assigned to delete target will be migrate to the ticket component_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_project_ticket_component_with_http_info(id_or_name, component_id, migrate_to, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_project_ticket_component ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_project_ticket_component" if id_or_name.nil?
      # verify the required parameter 'component_id' is set
      fail ArgumentError, "Missing the required parameter 'component_id' when calling ProjectApi.delete_project_ticket_component" if component_id.nil?
      # verify the required parameter 'migrate_to' is set
      fail ArgumentError, "Missing the required parameter 'migrate_to' when calling ProjectApi.delete_project_ticket_component" if migrate_to.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/component/{component_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'component_id' + '}', component_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'migrate_to'] = migrate_to

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_project_ticket_component\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete project ticket milestone
    # @param id_or_name numeric project id or project name
    # @param milestone_id numeric project ticket milestone id
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :migrate_to Tickets that assigned to delete target will be migrate to the ticket milestone_id
    # @return [nil]
    def delete_project_ticket_milestone(id_or_name, milestone_id, opts = {})
      delete_project_ticket_milestone_with_http_info(id_or_name, milestone_id, opts)
      return nil
    end

    # 
    # Delete project ticket milestone
    # @param id_or_name numeric project id or project name
    # @param milestone_id numeric project ticket milestone id
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :migrate_to Tickets that assigned to delete target will be migrate to the ticket milestone_id
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_project_ticket_milestone_with_http_info(id_or_name, milestone_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_project_ticket_milestone ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_project_ticket_milestone" if id_or_name.nil?
      # verify the required parameter 'milestone_id' is set
      fail ArgumentError, "Missing the required parameter 'milestone_id' when calling ProjectApi.delete_project_ticket_milestone" if milestone_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/milestone/{milestone_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'milestone_id' + '}', milestone_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'migrate_to'] = opts[:'migrate_to'] if !opts[:'migrate_to'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_project_ticket_milestone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete project ticket type
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param migrate_to Tickets that assigned to delete target will be migrate to the ticket type_id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_project_ticket_type(id_or_name, type_id, migrate_to, opts = {})
      delete_project_ticket_type_with_http_info(id_or_name, type_id, migrate_to, opts)
      return nil
    end

    # 
    # Delete project ticket type
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param migrate_to Tickets that assigned to delete target will be migrate to the ticket type_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_project_ticket_type_with_http_info(id_or_name, type_id, migrate_to, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_project_ticket_type ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_project_ticket_type" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectApi.delete_project_ticket_type" if type_id.nil?
      # verify the required parameter 'migrate_to' is set
      fail ArgumentError, "Missing the required parameter 'migrate_to' when calling ProjectApi.delete_project_ticket_type" if migrate_to.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'migrate_to'] = migrate_to

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_project_ticket_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete project ticket type instructions on the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_project_ticket_type_instruction(id_or_name, type_id, language_code, opts = {})
      delete_project_ticket_type_instruction_with_http_info(id_or_name, type_id, language_code, opts)
      return nil
    end

    # 
    # Delete project ticket type instructions on the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_project_ticket_type_instruction_with_http_info(id_or_name, type_id, language_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_project_ticket_type_instruction ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_project_ticket_type_instruction" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectApi.delete_project_ticket_type_instruction" if type_id.nil?
      # verify the required parameter 'language_code' is set
      fail ArgumentError, "Missing the required parameter 'language_code' when calling ProjectApi.delete_project_ticket_type_instruction" if language_code.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}/instruction/{language_code}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s).sub('{' + 'language_code' + '}', language_code.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_project_ticket_type_instruction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete target release.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_release(id_or_name, package_id, release_id, opts = {})
      delete_release_with_http_info(id_or_name, package_id, release_id, opts)
      return nil
    end

    # 
    # Delete target release.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_release_with_http_info(id_or_name, package_id, release_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_release ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_release" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.delete_release" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.delete_release" if release_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_release\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete target file.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_release_file(id_or_name, package_id, release_id, file_id, opts = {})
      delete_release_file_with_http_info(id_or_name, package_id, release_id, file_id, opts)
      return nil
    end

    # 
    # Delete target file.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_release_file_with_http_info(id_or_name, package_id, release_id, file_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_release_file ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_release_file" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.delete_release_file" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.delete_release_file" if release_id.nil?
      # verify the required parameter 'file_id' is set
      fail ArgumentError, "Missing the required parameter 'file_id' when calling ProjectApi.delete_release_file" if file_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}/{file_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s).sub('{' + 'file_id' + '}', file_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_release_file\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Disable a bzr repository (not an actual delete, just a shorthand for updating with active=false)
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [ProjectBzr]
    def disable_project_bzr(id_or_name, repo_id, opts = {})
      data, _status_code, _headers = disable_project_bzr_with_http_info(id_or_name, repo_id, opts)
      return data
    end

    # 
    # Disable a bzr repository (not an actual delete, just a shorthand for updating with active&#x3D;false)
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectBzr, Fixnum, Hash)>] ProjectBzr data, response status code and response headers
    def disable_project_bzr_with_http_info(id_or_name, repo_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.disable_project_bzr ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.disable_project_bzr" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.disable_project_bzr" if repo_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/bzr/{repo_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectBzr')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#disable_project_bzr\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Disable a git repository (not an actual delete, just a shorthand for updating with active=false)
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [ProjectGit]
    def disable_project_git(id_or_name, repo_id, opts = {})
      data, _status_code, _headers = disable_project_git_with_http_info(id_or_name, repo_id, opts)
      return data
    end

    # 
    # Disable a git repository (not an actual delete, just a shorthand for updating with active&#x3D;false)
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectGit, Fixnum, Hash)>] ProjectGit data, response status code and response headers
    def disable_project_git_with_http_info(id_or_name, repo_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.disable_project_git ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.disable_project_git" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.disable_project_git" if repo_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/git/{repo_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectGit')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#disable_project_git\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Disable a hg repository (not an actual delete, just a shorthand for updating with active=false)
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [ProjectHg]
    def disable_project_hg(id_or_name, repo_id, opts = {})
      data, _status_code, _headers = disable_project_hg_with_http_info(id_or_name, repo_id, opts)
      return data
    end

    # 
    # Disable a hg repository (not an actual delete, just a shorthand for updating with active&#x3D;false)
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectHg, Fixnum, Hash)>] ProjectHg data, response status code and response headers
    def disable_project_hg_with_http_info(id_or_name, repo_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.disable_project_hg ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.disable_project_hg" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.disable_project_hg" if repo_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/hg/{repo_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectHg')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#disable_project_hg\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get release draft in specified package. If draft is not exist, it will be created automatically.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @return [Release]
    def draft_release(id_or_name, package_id, opts = {})
      data, _status_code, _headers = draft_release_with_http_info(id_or_name, package_id, opts)
      return data
    end

    # 
    # Get release draft in specified package. If draft is not exist, it will be created automatically.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Release, Fixnum, Hash)>] Release data, response status code and response headers
    def draft_release_with_http_info(id_or_name, package_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.draft_release ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.draft_release" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.draft_release" if package_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/draft".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Release')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#draft_release\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project frs admin preferences.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [FrsAdminPrefs]
    def get_frs_adminprefs(id_or_name, opts = {})
      data, _status_code, _headers = get_frs_adminprefs_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project frs admin preferences.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(FrsAdminPrefs, Fixnum, Hash)>] FrsAdminPrefs data, response status code and response headers
    def get_frs_adminprefs_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_frs_adminprefs ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_frs_adminprefs" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/admin".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FrsAdminPrefs')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_frs_adminprefs\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get single news object.
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [News]
    def get_news(news_id, opts = {})
      data, _status_code, _headers = get_news_with_http_info(news_id, opts)
      return data
    end

    # 
    # Get single news object.
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(News, Fixnum, Hash)>] News data, response status code and response headers
    def get_news_with_http_info(news_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_news ..."
      end
      # verify the required parameter 'news_id' is set
      fail ArgumentError, "Missing the required parameter 'news_id' when calling ProjectApi.get_news" if news_id.nil?
      # resource path
      local_var_path = "/news/{news_id}".sub('{format}','json').sub('{' + 'news_id' + '}', news_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'News')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_news\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get single news object.
    # @param id_or_name numeric project id or project name
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [News]
    def get_news_0(id_or_name, news_id, opts = {})
      data, _status_code, _headers = get_news_0_with_http_info(id_or_name, news_id, opts)
      return data
    end

    # 
    # Get single news object.
    # @param id_or_name numeric project id or project name
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(News, Fixnum, Hash)>] News data, response status code and response headers
    def get_news_0_with_http_info(id_or_name, news_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_news_0 ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_news_0" if id_or_name.nil?
      # verify the required parameter 'news_id' is set
      fail ArgumentError, "Missing the required parameter 'news_id' when calling ProjectApi.get_news_0" if news_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/news/{news_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'news_id' + '}', news_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'News')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_news_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get specified package info and release list of the package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @return [Package]
    def get_package(id_or_name, package_id, opts = {})
      data, _status_code, _headers = get_package_with_http_info(id_or_name, package_id, opts)
      return data
    end

    # 
    # Get specified package info and release list of the package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Package, Fixnum, Hash)>] Package data, response status code and response headers
    def get_package_with_http_info(id_or_name, package_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_package ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_package" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.get_package" if package_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Package')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_package\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project info.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Group]
    def get_project(id_or_name, opts = {})
      data, _status_code, _headers = get_project_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project info.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Group, Fixnum, Hash)>] Group data, response status code and response headers
    def get_project_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Group')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project homepage url
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [ProjectWeb]
    def get_project_admin_projectweb(id_or_name, opts = {})
      data, _status_code, _headers = get_project_admin_projectweb_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project homepage url
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectWeb, Fixnum, Hash)>] ProjectWeb data, response status code and response headers
    def get_project_admin_projectweb_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_admin_projectweb ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_admin_projectweb" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/admin/project_web".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectWeb')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_admin_projectweb\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get a bzr repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [ProjectBzr]
    def get_project_bzr(id_or_name, repo_id, opts = {})
      data, _status_code, _headers = get_project_bzr_with_http_info(id_or_name, repo_id, opts)
      return data
    end

    # 
    # Get a bzr repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectBzr, Fixnum, Hash)>] ProjectBzr data, response status code and response headers
    def get_project_bzr_with_http_info(id_or_name, repo_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_bzr ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_bzr" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.get_project_bzr" if repo_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/bzr/{repo_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectBzr')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_bzr\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get a git repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [ProjectGit]
    def get_project_git(id_or_name, repo_id, opts = {})
      data, _status_code, _headers = get_project_git_with_http_info(id_or_name, repo_id, opts)
      return data
    end

    # 
    # Get a git repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectGit, Fixnum, Hash)>] ProjectGit data, response status code and response headers
    def get_project_git_with_http_info(id_or_name, repo_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_git ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_git" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.get_project_git" if repo_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/git/{repo_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectGit')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_git\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get a repository hook
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param hook_id 
    # @param [Hash] opts the optional parameters
    # @return [ScmHook]
    def get_project_git_hook(id_or_name, repo_id, hook_id, opts = {})
      data, _status_code, _headers = get_project_git_hook_with_http_info(id_or_name, repo_id, hook_id, opts)
      return data
    end

    # 
    # Get a repository hook
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param hook_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ScmHook, Fixnum, Hash)>] ScmHook data, response status code and response headers
    def get_project_git_hook_with_http_info(id_or_name, repo_id, hook_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_git_hook ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_git_hook" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.get_project_git_hook" if repo_id.nil?
      # verify the required parameter 'hook_id' is set
      fail ArgumentError, "Missing the required parameter 'hook_id' when calling ProjectApi.get_project_git_hook" if hook_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/git/{repo_id}/hooks/{hook_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s).sub('{' + 'hook_id' + '}', hook_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ScmHook')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_git_hook\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get a hg repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [ProjectHg]
    def get_project_hg(id_or_name, repo_id, opts = {})
      data, _status_code, _headers = get_project_hg_with_http_info(id_or_name, repo_id, opts)
      return data
    end

    # 
    # Get a hg repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectHg, Fixnum, Hash)>] ProjectHg data, response status code and response headers
    def get_project_hg_with_http_info(id_or_name, repo_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_hg ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_hg" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.get_project_hg" if repo_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/hg/{repo_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectHg')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_hg\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project histories.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<History>]
    def get_project_histories(id_or_name, opts = {})
      data, _status_code, _headers = get_project_histories_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project histories.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<History>, Fixnum, Hash)>] Array<History> data, response status code and response headers
    def get_project_histories_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_histories ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_histories" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/history".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<History>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_histories\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project profile on the language
    # @param id_or_name numeric project id or project name
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @return [GroupProfilePerLanguage]
    def get_project_profile(id_or_name, language_code, opts = {})
      data, _status_code, _headers = get_project_profile_with_http_info(id_or_name, language_code, opts)
      return data
    end

    # 
    # Get project profile on the language
    # @param id_or_name numeric project id or project name
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupProfilePerLanguage, Fixnum, Hash)>] GroupProfilePerLanguage data, response status code and response headers
    def get_project_profile_with_http_info(id_or_name, language_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_profile ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_profile" if id_or_name.nil?
      # verify the required parameter 'language_code' is set
      fail ArgumentError, "Missing the required parameter 'language_code' when calling ProjectApi.get_project_profile" if language_code.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/admin/profile/{language_code}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'language_code' + '}', language_code.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GroupProfilePerLanguage')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project profile in all languages
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [GroupProfile]
    def get_project_profile_list(id_or_name, opts = {})
      data, _status_code, _headers = get_project_profile_list_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project profile in all languages
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupProfile, Fixnum, Hash)>] GroupProfile data, response status code and response headers
    def get_project_profile_list_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_profile_list ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_profile_list" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/admin/profile".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GroupProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_profile_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get Subversion repository of the project
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [ProjectSvn]
    def get_project_svn(id_or_name, opts = {})
      data, _status_code, _headers = get_project_svn_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get Subversion repository of the project
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectSvn, Fixnum, Hash)>] ProjectSvn data, response status code and response headers
    def get_project_svn_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_svn ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_svn" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/svn".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectSvn')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_svn\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketItem]
    def get_project_ticket(id_or_name, ticket_id, opts = {})
      data, _status_code, _headers = get_project_ticket_with_http_info(id_or_name, ticket_id, opts)
      return data
    end

    # 
    # Get project ticket
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketItem, Fixnum, Hash)>] ProjectTicketItem data, response status code and response headers
    def get_project_ticket_with_http_info(id_or_name, ticket_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_ticket ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_ticket" if id_or_name.nil?
      # verify the required parameter 'ticket_id' is set
      fail ArgumentError, "Missing the required parameter 'ticket_id' when calling ProjectApi.get_project_ticket" if ticket_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/{ticket_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'ticket_id' + '}', ticket_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketItem')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_ticket\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket component
    # @param id_or_name numeric project id or project name
    # @param component_id numeric project ticket component id
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketComponent]
    def get_project_ticket_component(id_or_name, component_id, opts = {})
      data, _status_code, _headers = get_project_ticket_component_with_http_info(id_or_name, component_id, opts)
      return data
    end

    # 
    # Get project ticket component
    # @param id_or_name numeric project id or project name
    # @param component_id numeric project ticket component id
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketComponent, Fixnum, Hash)>] ProjectTicketComponent data, response status code and response headers
    def get_project_ticket_component_with_http_info(id_or_name, component_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_ticket_component ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_ticket_component" if id_or_name.nil?
      # verify the required parameter 'component_id' is set
      fail ArgumentError, "Missing the required parameter 'component_id' when calling ProjectApi.get_project_ticket_component" if component_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/component/{component_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'component_id' + '}', component_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketComponent')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_ticket_component\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket milestone of spscified milestone_id.
    # @param id_or_name numeric project id or project name
    # @param milestone_id numeric project ticket milestone id
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketMilestone]
    def get_project_ticket_milestone(id_or_name, milestone_id, opts = {})
      data, _status_code, _headers = get_project_ticket_milestone_with_http_info(id_or_name, milestone_id, opts)
      return data
    end

    # 
    # Get project ticket milestone of spscified milestone_id.
    # @param id_or_name numeric project id or project name
    # @param milestone_id numeric project ticket milestone id
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketMilestone, Fixnum, Hash)>] ProjectTicketMilestone data, response status code and response headers
    def get_project_ticket_milestone_with_http_info(id_or_name, milestone_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_ticket_milestone ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_ticket_milestone" if id_or_name.nil?
      # verify the required parameter 'milestone_id' is set
      fail ArgumentError, "Missing the required parameter 'milestone_id' when calling ProjectApi.get_project_ticket_milestone" if milestone_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/milestone/{milestone_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'milestone_id' + '}', milestone_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketMilestone')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_ticket_milestone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket type
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketType]
    def get_project_ticket_type(id_or_name, type_id, opts = {})
      data, _status_code, _headers = get_project_ticket_type_with_http_info(id_or_name, type_id, opts)
      return data
    end

    # 
    # Get project ticket type
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketType, Fixnum, Hash)>] ProjectTicketType data, response status code and response headers
    def get_project_ticket_type_with_http_info(id_or_name, type_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_ticket_type ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_ticket_type" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectApi.get_project_ticket_type" if type_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketType')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_ticket_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket type instructions on the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketTypeInstructionPerLanguage]
    def get_project_ticket_type_instruction(id_or_name, type_id, language_code, opts = {})
      data, _status_code, _headers = get_project_ticket_type_instruction_with_http_info(id_or_name, type_id, language_code, opts)
      return data
    end

    # 
    # Get project ticket type instructions on the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketTypeInstructionPerLanguage, Fixnum, Hash)>] ProjectTicketTypeInstructionPerLanguage data, response status code and response headers
    def get_project_ticket_type_instruction_with_http_info(id_or_name, type_id, language_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_ticket_type_instruction ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_ticket_type_instruction" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectApi.get_project_ticket_type_instruction" if type_id.nil?
      # verify the required parameter 'language_code' is set
      fail ArgumentError, "Missing the required parameter 'language_code' when calling ProjectApi.get_project_ticket_type_instruction" if language_code.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}/instruction/{language_code}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s).sub('{' + 'language_code' + '}', language_code.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketTypeInstructionPerLanguage')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_ticket_type_instruction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project ticket type instructions on the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param instruction Ticket submit instruction for the type
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketTypeInstructionPerLanguage]
    def get_project_ticket_type_instruction_0(id_or_name, type_id, language_code, instruction, opts = {})
      data, _status_code, _headers = get_project_ticket_type_instruction_0_with_http_info(id_or_name, type_id, language_code, instruction, opts)
      return data
    end

    # 
    # Update project ticket type instructions on the language
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param instruction Ticket submit instruction for the type
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketTypeInstructionPerLanguage, Fixnum, Hash)>] ProjectTicketTypeInstructionPerLanguage data, response status code and response headers
    def get_project_ticket_type_instruction_0_with_http_info(id_or_name, type_id, language_code, instruction, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_ticket_type_instruction_0 ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_ticket_type_instruction_0" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectApi.get_project_ticket_type_instruction_0" if type_id.nil?
      # verify the required parameter 'language_code' is set
      fail ArgumentError, "Missing the required parameter 'language_code' when calling ProjectApi.get_project_ticket_type_instruction_0" if language_code.nil?
      # verify the required parameter 'instruction' is set
      fail ArgumentError, "Missing the required parameter 'instruction' when calling ProjectApi.get_project_ticket_type_instruction_0" if instruction.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}/instruction/{language_code}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s).sub('{' + 'language_code' + '}', language_code.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["instruction"] = instruction

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketTypeInstructionPerLanguage')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_ticket_type_instruction_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project tools info.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [GroupToolFlags]
    def get_project_tools(id_or_name, opts = {})
      data, _status_code, _headers = get_project_tools_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project tools info.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupToolFlags, Fixnum, Hash)>] GroupToolFlags data, response status code and response headers
    def get_project_tools_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project_tools ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project_tools" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/admin/tools".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GroupToolFlags')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project_tools\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get specified release info and file list of the release.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param [Hash] opts the optional parameters
    # @return [Release]
    def get_release(id_or_name, package_id, release_id, opts = {})
      data, _status_code, _headers = get_release_with_http_info(id_or_name, package_id, release_id, opts)
      return data
    end

    # 
    # Get specified release info and file list of the release.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Release, Fixnum, Hash)>] Release data, response status code and response headers
    def get_release_with_http_info(id_or_name, package_id, release_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_release ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_release" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.get_release" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.get_release" if release_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Release')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_release\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get single file object.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file_id 
    # @param [Hash] opts the optional parameters
    # @return [RelFile]
    def get_release_file(id_or_name, package_id, release_id, file_id, opts = {})
      data, _status_code, _headers = get_release_file_with_http_info(id_or_name, package_id, release_id, file_id, opts)
      return data
    end

    # 
    # Get single file object.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(RelFile, Fixnum, Hash)>] RelFile data, response status code and response headers
    def get_release_file_with_http_info(id_or_name, package_id, release_id, file_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_release_file ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_release_file" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.get_release_file" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.get_release_file" if release_id.nil?
      # verify the required parameter 'file_id' is set
      fail ArgumentError, "Missing the required parameter 'file_id' when calling ProjectApi.get_release_file" if file_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}/{file_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s).sub('{' + 'file_id' + '}', file_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RelFile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_release_file\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :group_id filter by group ID
    # @return [Array<News>]
    def list_news(opts = {})
      data, _status_code, _headers = list_news_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :group_id filter by group ID
    # @return [Array<(Array<News>, Fixnum, Hash)>] Array<News> data, response status code and response headers
    def list_news_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_news ..."
      end
      # resource path
      local_var_path = "/news".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'group_id'] = opts[:'group_id'] if !opts[:'group_id'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<News>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_news\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get news list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<News>]
    def list_news_0(id_or_name, opts = {})
      data, _status_code, _headers = list_news_0_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get news list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<News>, Fixnum, Hash)>] Array<News> data, response status code and response headers
    def list_news_0_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_news_0 ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_news_0" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/news".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<News>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_news_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get package list of specified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<Package>]
    def list_packages(id_or_name, opts = {})
      data, _status_code, _headers = list_packages_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get package list of specified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<Package>, Fixnum, Hash)>] Array<Package> data, response status code and response headers
    def list_packages_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_packages ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_packages" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<Package>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_packages\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get Bazzar repository list
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<ProjectBzr>]
    def list_project_bzr(id_or_name, opts = {})
      data, _status_code, _headers = list_project_bzr_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get Bazzar repository list
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ProjectBzr>, Fixnum, Hash)>] Array<ProjectBzr> data, response status code and response headers
    def list_project_bzr_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_project_bzr ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_project_bzr" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/bzr".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectBzr>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_project_bzr\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get git repository list
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<ProjectGit>]
    def list_project_git(id_or_name, opts = {})
      data, _status_code, _headers = list_project_git_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get git repository list
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ProjectGit>, Fixnum, Hash)>] Array<ProjectGit> data, response status code and response headers
    def list_project_git_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_project_git ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_project_git" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/git".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectGit>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_project_git\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get Git repository hook list
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<ScmHook>]
    def list_project_git_hook(id_or_name, repo_id, opts = {})
      data, _status_code, _headers = list_project_git_hook_with_http_info(id_or_name, repo_id, opts)
      return data
    end

    # 
    # Get Git repository hook list
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ScmHook>, Fixnum, Hash)>] Array<ScmHook> data, response status code and response headers
    def list_project_git_hook_with_http_info(id_or_name, repo_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_project_git_hook ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_project_git_hook" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.list_project_git_hook" if repo_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/git/{repo_id}/hooks".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ScmHook>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_project_git_hook\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get Mercurial repository list
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<ProjectHg>]
    def list_project_hg(id_or_name, opts = {})
      data, _status_code, _headers = list_project_hg_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get Mercurial repository list
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ProjectHg>, Fixnum, Hash)>] Array<ProjectHg> data, response status code and response headers
    def list_project_hg_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_project_hg ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_project_hg" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/hg".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectHg>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_project_hg\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # List project ticket order by submit date descending
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :status Tickets are assigned to these type_ids
    # @option opts [Array<Integer>] :type_id Listing tickets are assigned to these type_ids
    # @option opts [Array<Integer>] :not_type_id Listing tickets are NOT assigned to these type_ids
    # @option opts [Array<Integer>] :component_id Listing tickets are assigned to these component_ids (If you want to indicate component is not assigned, please use component_id &#x3D; 0)
    # @option opts [Array<Integer>] :not_component_id Listing tickets are NOT assigned to these component_ids (If you want to indicate component is not assigned, please use component_id &#x3D; 0)
    # @option opts [Array<Integer>] :milestone_id Listing tickets are assigned to these milestone_ids (If you want to indicate milestone is not assigned, please use milestone_id &#x3D; 0)
    # @option opts [Array<Integer>] :not_milestone_id Listing tickets are NOT assigned to these milestone_ids (milestone_id &#x3D; 0 means milestone not assigned)
    # @option opts [Integer] :max_priority Listing equal or lower priority tickets
    # @option opts [Integer] :min_priority Listing equal or higher priority tickets
    # @option opts [Integer] :priority Listing tickets have this priority
    # @option opts [Integer] :max_severity Listing equal or lower severity tickets
    # @option opts [Integer] :min_severity Listing equal or higher severity tickets
    # @option opts [Integer] :severity Listing tickets have this severity
    # @option opts [Array<Integer>] :owner Listing tickets assigned to these owners (owner &#x3D; 100 means owner is not assigned)
    # @option opts [Array<Integer>] :not_owner Listing tickets NOT assigned to these owners (owner &#x3D; 100 means owner is not assigned)
    # @option opts [Array<Integer>] :reporter Listing tickets reported by these users (report &#x3D; 100 means reported by non login user)
    # @option opts [Array<Integer>] :not_reporter Listing tickets reported by these users (report &#x3D; 100 means reported by non login user)
    # @option opts [String] :text Listing tickets title or description or comment include the text
    # @return [Array<ProjectTicketItem>]
    def list_project_ticket(id_or_name, opts = {})
      data, _status_code, _headers = list_project_ticket_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # List project ticket order by submit date descending
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :status Tickets are assigned to these type_ids
    # @option opts [Array<Integer>] :type_id Listing tickets are assigned to these type_ids
    # @option opts [Array<Integer>] :not_type_id Listing tickets are NOT assigned to these type_ids
    # @option opts [Array<Integer>] :component_id Listing tickets are assigned to these component_ids (If you want to indicate component is not assigned, please use component_id &#x3D; 0)
    # @option opts [Array<Integer>] :not_component_id Listing tickets are NOT assigned to these component_ids (If you want to indicate component is not assigned, please use component_id &#x3D; 0)
    # @option opts [Array<Integer>] :milestone_id Listing tickets are assigned to these milestone_ids (If you want to indicate milestone is not assigned, please use milestone_id &#x3D; 0)
    # @option opts [Array<Integer>] :not_milestone_id Listing tickets are NOT assigned to these milestone_ids (milestone_id &#x3D; 0 means milestone not assigned)
    # @option opts [Integer] :max_priority Listing equal or lower priority tickets
    # @option opts [Integer] :min_priority Listing equal or higher priority tickets
    # @option opts [Integer] :priority Listing tickets have this priority
    # @option opts [Integer] :max_severity Listing equal or lower severity tickets
    # @option opts [Integer] :min_severity Listing equal or higher severity tickets
    # @option opts [Integer] :severity Listing tickets have this severity
    # @option opts [Array<Integer>] :owner Listing tickets assigned to these owners (owner &#x3D; 100 means owner is not assigned)
    # @option opts [Array<Integer>] :not_owner Listing tickets NOT assigned to these owners (owner &#x3D; 100 means owner is not assigned)
    # @option opts [Array<Integer>] :reporter Listing tickets reported by these users (report &#x3D; 100 means reported by non login user)
    # @option opts [Array<Integer>] :not_reporter Listing tickets reported by these users (report &#x3D; 100 means reported by non login user)
    # @option opts [String] :text Listing tickets title or description or comment include the text
    # @return [Array<(Array<ProjectTicketItem>, Fixnum, Hash)>] Array<ProjectTicketItem> data, response status code and response headers
    def list_project_ticket_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_project_ticket ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_project_ticket" if id_or_name.nil?
      if opts[:'status'] && ![].include?(opts[:'status'])
        fail ArgumentError, 'invalid value for "status", must be one of '
      end
      if opts[:'max_priority'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"max_priority"]" when calling ProjectApi.list_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'max_priority'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"max_priority"]" when calling ProjectApi.list_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'min_priority'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"min_priority"]" when calling ProjectApi.list_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'min_priority'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"min_priority"]" when calling ProjectApi.list_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'priority'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"priority"]" when calling ProjectApi.list_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'priority'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"priority"]" when calling ProjectApi.list_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'max_severity'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"max_severity"]" when calling ProjectApi.list_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'max_severity'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"max_severity"]" when calling ProjectApi.list_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'min_severity'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"min_severity"]" when calling ProjectApi.list_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'min_severity'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"min_severity"]" when calling ProjectApi.list_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'severity'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"severity"]" when calling ProjectApi.list_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'severity'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"severity"]" when calling ProjectApi.list_project_ticket, must be greater than or equal to 1.0.'
      end

      # resource path
      local_var_path = "/project/{id_or_name}/ticket".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}
      query_params[:'status'] = @api_client.build_collection_param(opts[:'status'], :csv) if !opts[:'status'].nil?
      query_params[:'type_id'] = @api_client.build_collection_param(opts[:'type_id'], :csv) if !opts[:'type_id'].nil?
      query_params[:'not_type_id'] = @api_client.build_collection_param(opts[:'not_type_id'], :csv) if !opts[:'not_type_id'].nil?
      query_params[:'component_id'] = @api_client.build_collection_param(opts[:'component_id'], :csv) if !opts[:'component_id'].nil?
      query_params[:'not_component_id'] = @api_client.build_collection_param(opts[:'not_component_id'], :csv) if !opts[:'not_component_id'].nil?
      query_params[:'milestone_id'] = @api_client.build_collection_param(opts[:'milestone_id'], :csv) if !opts[:'milestone_id'].nil?
      query_params[:'not_milestone_id'] = @api_client.build_collection_param(opts[:'not_milestone_id'], :csv) if !opts[:'not_milestone_id'].nil?
      query_params[:'max_priority'] = opts[:'max_priority'] if !opts[:'max_priority'].nil?
      query_params[:'min_priority'] = opts[:'min_priority'] if !opts[:'min_priority'].nil?
      query_params[:'priority'] = opts[:'priority'] if !opts[:'priority'].nil?
      query_params[:'max_severity'] = opts[:'max_severity'] if !opts[:'max_severity'].nil?
      query_params[:'min_severity'] = opts[:'min_severity'] if !opts[:'min_severity'].nil?
      query_params[:'severity'] = opts[:'severity'] if !opts[:'severity'].nil?
      query_params[:'owner'] = @api_client.build_collection_param(opts[:'owner'], :csv) if !opts[:'owner'].nil?
      query_params[:'not_owner'] = @api_client.build_collection_param(opts[:'not_owner'], :csv) if !opts[:'not_owner'].nil?
      query_params[:'reporter'] = @api_client.build_collection_param(opts[:'reporter'], :csv) if !opts[:'reporter'].nil?
      query_params[:'not_reporter'] = @api_client.build_collection_param(opts[:'not_reporter'], :csv) if !opts[:'not_reporter'].nil?
      query_params[:'text'] = opts[:'text'] if !opts[:'text'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectTicketItem>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_project_ticket\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket comment list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param [Hash] opts the optional parameters
    # @return [Array<ProjectTicketComment>]
    def list_project_ticket_comment(id_or_name, ticket_id, opts = {})
      data, _status_code, _headers = list_project_ticket_comment_with_http_info(id_or_name, ticket_id, opts)
      return data
    end

    # 
    # Get project ticket comment list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ProjectTicketComment>, Fixnum, Hash)>] Array<ProjectTicketComment> data, response status code and response headers
    def list_project_ticket_comment_with_http_info(id_or_name, ticket_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_project_ticket_comment ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_project_ticket_comment" if id_or_name.nil?
      # verify the required parameter 'ticket_id' is set
      fail ArgumentError, "Missing the required parameter 'ticket_id' when calling ProjectApi.list_project_ticket_comment" if ticket_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/{ticket_id}/comment".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'ticket_id' + '}', ticket_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectTicketComment>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_project_ticket_comment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket component list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<ProjectTicketComponent>]
    def list_project_ticket_component(id_or_name, opts = {})
      data, _status_code, _headers = list_project_ticket_component_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project ticket component list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ProjectTicketComponent>, Fixnum, Hash)>] Array<ProjectTicketComponent> data, response status code and response headers
    def list_project_ticket_component_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_project_ticket_component ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_project_ticket_component" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/component".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectTicketComponent>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_project_ticket_component\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket milestone list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<ProjectTicketMilestone>]
    def list_project_ticket_milestone(id_or_name, opts = {})
      data, _status_code, _headers = list_project_ticket_milestone_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project ticket milestone list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ProjectTicketMilestone>, Fixnum, Hash)>] Array<ProjectTicketMilestone> data, response status code and response headers
    def list_project_ticket_milestone_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_project_ticket_milestone ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_project_ticket_milestone" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/milestone".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectTicketMilestone>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_project_ticket_milestone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket type list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<ProjectTicketType>]
    def list_project_ticket_type(id_or_name, opts = {})
      data, _status_code, _headers = list_project_ticket_type_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project ticket type list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ProjectTicketType>, Fixnum, Hash)>] Array<ProjectTicketType> data, response status code and response headers
    def list_project_ticket_type_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_project_ticket_type ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_project_ticket_type" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<ProjectTicketType>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_project_ticket_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket type instructions
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketTypeInstructions]
    def list_project_ticket_type_instruction(id_or_name, type_id, opts = {})
      data, _status_code, _headers = list_project_ticket_type_instruction_with_http_info(id_or_name, type_id, opts)
      return data
    end

    # 
    # Get project ticket type instructions
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketTypeInstructions, Fixnum, Hash)>] ProjectTicketTypeInstructions data, response status code and response headers
    def list_project_ticket_type_instruction_with_http_info(id_or_name, type_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_project_ticket_type_instruction ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_project_ticket_type_instruction" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectApi.list_project_ticket_type_instruction" if type_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}/instruction".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketTypeInstructions')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_project_ticket_type_instruction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket admin preferences.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketPrefs]
    def show_project_ticket_adminprefs(id_or_name, opts = {})
      data, _status_code, _headers = show_project_ticket_adminprefs_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project ticket admin preferences.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketPrefs, Fixnum, Hash)>] ProjectTicketPrefs data, response status code and response headers
    def show_project_ticket_adminprefs_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.show_project_ticket_adminprefs ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.show_project_ticket_adminprefs" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/admin".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketPrefs')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#show_project_ticket_adminprefs\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project ticket comment spscified project.
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param comment_id numeric project ticket comment id
    # @param [Hash] opts the optional parameters
    # @return [ProjectTicketComment]
    def show_project_ticket_comment(id_or_name, ticket_id, comment_id, opts = {})
      data, _status_code, _headers = show_project_ticket_comment_with_http_info(id_or_name, ticket_id, comment_id, opts)
      return data
    end

    # 
    # Get project ticket comment spscified project.
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param comment_id numeric project ticket comment id
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProjectTicketComment, Fixnum, Hash)>] ProjectTicketComment data, response status code and response headers
    def show_project_ticket_comment_with_http_info(id_or_name, ticket_id, comment_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.show_project_ticket_comment ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.show_project_ticket_comment" if id_or_name.nil?
      # verify the required parameter 'ticket_id' is set
      fail ArgumentError, "Missing the required parameter 'ticket_id' when calling ProjectApi.show_project_ticket_comment" if ticket_id.nil?
      # verify the required parameter 'comment_id' is set
      fail ArgumentError, "Missing the required parameter 'comment_id' when calling ProjectApi.show_project_ticket_comment" if comment_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/{ticket_id}/comment/{comment_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'ticket_id' + '}', ticket_id.to_s).sub('{' + 'comment_id' + '}', comment_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketComment')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#show_project_ticket_comment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project frs admin preferences.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :allow_overwrite Allow overwrite files when filenames are conflict
    # @return [FrsAdminPrefs]
    def update_frs_adminprefs(id_or_name, opts = {})
      data, _status_code, _headers = update_frs_adminprefs_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Update project frs admin preferences.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :allow_overwrite Allow overwrite files when filenames are conflict
    # @return [Array<(FrsAdminPrefs, Fixnum, Hash)>] FrsAdminPrefs data, response status code and response headers
    def update_frs_adminprefs_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_frs_adminprefs ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_frs_adminprefs" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/admin".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["allow_overwrite"] = opts[:'allow_overwrite'] if !opts[:'allow_overwrite'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FrsAdminPrefs')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_frs_adminprefs\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :title news title
    # @option opts [String] :body news body in OSDN Wiki format.
    # @return [News]
    def update_news(news_id, opts = {})
      data, _status_code, _headers = update_news_with_http_info(news_id, opts)
      return data
    end

    # 
    # 
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :title news title
    # @option opts [String] :body news body in OSDN Wiki format.
    # @return [Array<(News, Fixnum, Hash)>] News data, response status code and response headers
    def update_news_with_http_info(news_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_news ..."
      end
      # verify the required parameter 'news_id' is set
      fail ArgumentError, "Missing the required parameter 'news_id' when calling ProjectApi.update_news" if news_id.nil?
      # resource path
      local_var_path = "/news/{news_id}".sub('{format}','json').sub('{' + 'news_id' + '}', news_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["title"] = opts[:'title'] if !opts[:'title'].nil?
      form_params["body"] = opts[:'body'] if !opts[:'body'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'News')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_news\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param news_id 
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :title news title
    # @option opts [String] :body news body in OSDN Wiki format.
    # @return [News]
    def update_news_0(news_id, id_or_name, opts = {})
      data, _status_code, _headers = update_news_0_with_http_info(news_id, id_or_name, opts)
      return data
    end

    # 
    # 
    # @param news_id 
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :title news title
    # @option opts [String] :body news body in OSDN Wiki format.
    # @return [Array<(News, Fixnum, Hash)>] News data, response status code and response headers
    def update_news_0_with_http_info(news_id, id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_news_0 ..."
      end
      # verify the required parameter 'news_id' is set
      fail ArgumentError, "Missing the required parameter 'news_id' when calling ProjectApi.update_news_0" if news_id.nil?
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_news_0" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/news/{news_id}".sub('{format}','json').sub('{' + 'news_id' + '}', news_id.to_s).sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["title"] = opts[:'title'] if !opts[:'title'].nil?
      form_params["body"] = opts[:'body'] if !opts[:'body'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'News')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_news_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update tagret package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name package name
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [Package]
    def update_package(id_or_name, package_id, opts = {})
      data, _status_code, _headers = update_package_with_http_info(id_or_name, package_id, opts)
      return data
    end

    # 
    # Update tagret package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name package name
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [Array<(Package, Fixnum, Hash)>] Package data, response status code and response headers
    def update_package_with_http_info(id_or_name, package_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_package ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_package" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.update_package" if package_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = opts[:'name'] if !opts[:'name'].nil?
      form_params["visibility"] = opts[:'visibility'] if !opts[:'visibility'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Package')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_package\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project homepage url
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :homepage Project home page full URL (should start with http:// or https://). If reset param is true, this url will be ignored (URL will be reset to default url)
    # @option opts [BOOLEAN] :reset Project home page URL reset to default value
    # @return [ProjectWeb]
    def update_project_admin_projectweb(id_or_name, opts = {})
      data, _status_code, _headers = update_project_admin_projectweb_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Update project homepage url
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :homepage Project home page full URL (should start with http:// or https://). If reset param is true, this url will be ignored (URL will be reset to default url)
    # @option opts [BOOLEAN] :reset Project home page URL reset to default value
    # @return [Array<(ProjectWeb, Fixnum, Hash)>] ProjectWeb data, response status code and response headers
    def update_project_admin_projectweb_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_project_admin_projectweb ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_project_admin_projectweb" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/admin/project_web".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["homepage"] = opts[:'homepage'] if !opts[:'homepage'].nil?
      form_params["reset"] = opts[:'reset'] if !opts[:'reset'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectWeb')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_project_admin_projectweb\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update a bzr repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :description 
    # @option opts [BOOLEAN] :active 
    # @return [ProjectBzr]
    def update_project_bzr(id_or_name, repo_id, opts = {})
      data, _status_code, _headers = update_project_bzr_with_http_info(id_or_name, repo_id, opts)
      return data
    end

    # 
    # Update a bzr repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :description 
    # @option opts [BOOLEAN] :active 
    # @return [Array<(ProjectBzr, Fixnum, Hash)>] ProjectBzr data, response status code and response headers
    def update_project_bzr_with_http_info(id_or_name, repo_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_project_bzr ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_project_bzr" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.update_project_bzr" if repo_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/bzr/{repo_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["active"] = opts[:'active'] if !opts[:'active'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectBzr')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_project_bzr\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update a git repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :description 
    # @option opts [BOOLEAN] :mail_enabled 
    # @option opts [String] :mail_recipients 
    # @option opts [BOOLEAN] :allow_non_fast_forward 
    # @option opts [String] :default_branch 
    # @option opts [BOOLEAN] :active 
    # @return [ProjectGit]
    def update_project_git(id_or_name, repo_id, opts = {})
      data, _status_code, _headers = update_project_git_with_http_info(id_or_name, repo_id, opts)
      return data
    end

    # 
    # Update a git repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :description 
    # @option opts [BOOLEAN] :mail_enabled 
    # @option opts [String] :mail_recipients 
    # @option opts [BOOLEAN] :allow_non_fast_forward 
    # @option opts [String] :default_branch 
    # @option opts [BOOLEAN] :active 
    # @return [Array<(ProjectGit, Fixnum, Hash)>] ProjectGit data, response status code and response headers
    def update_project_git_with_http_info(id_or_name, repo_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_project_git ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_project_git" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.update_project_git" if repo_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/git/{repo_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["mail_enabled"] = opts[:'mail_enabled'] if !opts[:'mail_enabled'].nil?
      form_params["mail_recipients"] = opts[:'mail_recipients'] if !opts[:'mail_recipients'].nil?
      form_params["allow_non_fast_forward"] = opts[:'allow_non_fast_forward'] if !opts[:'allow_non_fast_forward'].nil?
      form_params["default_branch"] = opts[:'default_branch'] if !opts[:'default_branch'].nil?
      form_params["active"] = opts[:'active'] if !opts[:'active'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectGit')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_project_git\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update a hg repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :description 
    # @option opts [String] :mail_recipients 
    # @option opts [BOOLEAN] :active 
    # @return [ProjectHg]
    def update_project_hg(id_or_name, repo_id, opts = {})
      data, _status_code, _headers = update_project_hg_with_http_info(id_or_name, repo_id, opts)
      return data
    end

    # 
    # Update a hg repository
    # @param id_or_name numeric project id or project name
    # @param repo_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :description 
    # @option opts [String] :mail_recipients 
    # @option opts [BOOLEAN] :active 
    # @return [Array<(ProjectHg, Fixnum, Hash)>] ProjectHg data, response status code and response headers
    def update_project_hg_with_http_info(id_or_name, repo_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_project_hg ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_project_hg" if id_or_name.nil?
      # verify the required parameter 'repo_id' is set
      fail ArgumentError, "Missing the required parameter 'repo_id' when calling ProjectApi.update_project_hg" if repo_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/hg/{repo_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'repo_id' + '}', repo_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["mail_recipients"] = opts[:'mail_recipients'] if !opts[:'mail_recipients'].nil?
      form_params["active"] = opts[:'active'] if !opts[:'active'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectHg')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_project_hg\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project profile.
    # @param id_or_name numeric project id or project name
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :display_name Project display name
    # @option opts [String] :description Project description
    # @return [GroupProfilePerLanguage]
    def update_project_profile(id_or_name, language_code, opts = {})
      data, _status_code, _headers = update_project_profile_with_http_info(id_or_name, language_code, opts)
      return data
    end

    # 
    # Update project profile.
    # @param id_or_name numeric project id or project name
    # @param language_code Language code for display name and description (example en, ja, zh-TW)
    # @param [Hash] opts the optional parameters
    # @option opts [String] :display_name Project display name
    # @option opts [String] :description Project description
    # @return [Array<(GroupProfilePerLanguage, Fixnum, Hash)>] GroupProfilePerLanguage data, response status code and response headers
    def update_project_profile_with_http_info(id_or_name, language_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_project_profile ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_project_profile" if id_or_name.nil?
      # verify the required parameter 'language_code' is set
      fail ArgumentError, "Missing the required parameter 'language_code' when calling ProjectApi.update_project_profile" if language_code.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/admin/profile/{language_code}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'language_code' + '}', language_code.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["display_name"] = opts[:'display_name'] if !opts[:'display_name'].nil?
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GroupProfilePerLanguage')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_project_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project ticket
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Project ticket name (title)
    # @option opts [String] :description Project ticket description details
    # @option opts [Integer] :type_id numeric project ticket type id
    # @option opts [Integer] :milestone_id numeric project ticket milestone id
    # @option opts [Integer] :component_id numeric project ticket component id
    # @option opts [Integer] :priority project ticket priority (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :severity project ticket severity (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :owner numeric project ticket owner user id
    # @option opts [String] :resolution project ticket resolution text
    # @option opts [String] :status project ticket status (open or close)
    # @return [ProjectTicketItem]
    def update_project_ticket(id_or_name, ticket_id, opts = {})
      data, _status_code, _headers = update_project_ticket_with_http_info(id_or_name, ticket_id, opts)
      return data
    end

    # 
    # Update project ticket
    # @param id_or_name numeric project id or project name
    # @param ticket_id numeric project ticket id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Project ticket name (title)
    # @option opts [String] :description Project ticket description details
    # @option opts [Integer] :type_id numeric project ticket type id
    # @option opts [Integer] :milestone_id numeric project ticket milestone id
    # @option opts [Integer] :component_id numeric project ticket component id
    # @option opts [Integer] :priority project ticket priority (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :severity project ticket severity (min &#x3D; 1 and max &#x3D; 9)
    # @option opts [Integer] :owner numeric project ticket owner user id
    # @option opts [String] :resolution project ticket resolution text
    # @option opts [String] :status project ticket status (open or close)
    # @return [Array<(ProjectTicketItem, Fixnum, Hash)>] ProjectTicketItem data, response status code and response headers
    def update_project_ticket_with_http_info(id_or_name, ticket_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_project_ticket ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_project_ticket" if id_or_name.nil?
      # verify the required parameter 'ticket_id' is set
      fail ArgumentError, "Missing the required parameter 'ticket_id' when calling ProjectApi.update_project_ticket" if ticket_id.nil?
      if opts[:'priority'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"priority"]" when calling ProjectApi.update_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'priority'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"priority"]" when calling ProjectApi.update_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'severity'] > 9.0
        fail ArgumentError, 'invalid value for "opts[:"severity"]" when calling ProjectApi.update_project_ticket, must be smaller than or equal to 9.0.'
      end

      if opts[:'severity'] < 1.0
        fail ArgumentError, 'invalid value for "opts[:"severity"]" when calling ProjectApi.update_project_ticket, must be greater than or equal to 1.0.'
      end

      if opts[:'owner'] < 101.0
        fail ArgumentError, 'invalid value for "opts[:"owner"]" when calling ProjectApi.update_project_ticket, must be greater than or equal to 101.0.'
      end

      if opts[:'resolution'] && !['Fixed', 'Invalid', 'Wont Fix', 'Later', 'Remind', 'Works For Me', 'None', 'Duplicate', 'Accepted', 'Out of Date', 'Postponed', 'Rejected'].include?(opts[:'resolution'])
        fail ArgumentError, 'invalid value for "resolution", must be one of Fixed, Invalid, Wont Fix, Later, Remind, Works For Me, None, Duplicate, Accepted, Out of Date, Postponed, Rejected'
      end
      if opts[:'status'] && !['close', 'reopen'].include?(opts[:'status'])
        fail ArgumentError, 'invalid value for "status", must be one of close, reopen'
      end
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/{ticket_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'ticket_id' + '}', ticket_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = opts[:'name'] if !opts[:'name'].nil?
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["type_id"] = opts[:'type_id'] if !opts[:'type_id'].nil?
      form_params["milestone_id"] = opts[:'milestone_id'] if !opts[:'milestone_id'].nil?
      form_params["component_id"] = opts[:'component_id'] if !opts[:'component_id'].nil?
      form_params["priority"] = opts[:'priority'] if !opts[:'priority'].nil?
      form_params["severity"] = opts[:'severity'] if !opts[:'severity'].nil?
      form_params["owner"] = opts[:'owner'] if !opts[:'owner'].nil?
      form_params["resolution"] = opts[:'resolution'] if !opts[:'resolution'].nil?
      form_params["status"] = opts[:'status'] if !opts[:'status'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketItem')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_project_ticket\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project ticket admin preferences.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :allow_anonymouse Non login user allows to post new ticket/comment
    # @option opts [String] :frs_autosync Componet File release autosync type &#39;Disabled&#39;, &#39;Package&#39;, &#39;Release&#39;, &#39;Package and Release&#39;
    # @option opts [String] :mailsend_type Ticket update mail destination type &#39;None&#39;, &#39;Ticket Technician&#39;, &#39;Ticket Administrator&#39;, &#39;Ticket Administrator and Technician&#39;, &#39;All project members&#39;, &#39;Mailing List&#39;
    # @option opts [Integer] :mailing_list_id Ticket update mail destination mail list id (it is only used when mailsend_type is mailing list)
    # @option opts [String] :mail_lang Ticket update mail language
    # @return [ProjectTicketPrefs]
    def update_project_ticket_adminprefs(id_or_name, opts = {})
      data, _status_code, _headers = update_project_ticket_adminprefs_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Update project ticket admin preferences.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :allow_anonymouse Non login user allows to post new ticket/comment
    # @option opts [String] :frs_autosync Componet File release autosync type &#39;Disabled&#39;, &#39;Package&#39;, &#39;Release&#39;, &#39;Package and Release&#39;
    # @option opts [String] :mailsend_type Ticket update mail destination type &#39;None&#39;, &#39;Ticket Technician&#39;, &#39;Ticket Administrator&#39;, &#39;Ticket Administrator and Technician&#39;, &#39;All project members&#39;, &#39;Mailing List&#39;
    # @option opts [Integer] :mailing_list_id Ticket update mail destination mail list id (it is only used when mailsend_type is mailing list)
    # @option opts [String] :mail_lang Ticket update mail language
    # @return [Array<(ProjectTicketPrefs, Fixnum, Hash)>] ProjectTicketPrefs data, response status code and response headers
    def update_project_ticket_adminprefs_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_project_ticket_adminprefs ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_project_ticket_adminprefs" if id_or_name.nil?
      if opts[:'frs_autosync'] && !['Disabled', 'Package', 'Release', 'Package and Release'].include?(opts[:'frs_autosync'])
        fail ArgumentError, 'invalid value for "frs_autosync", must be one of Disabled, Package, Release, Package and Release'
      end
      if opts[:'mailsend_type'] && !['None', 'Ticket Technician', 'Ticket Administrator', 'Ticket Administrator and Technician', 'All project members', 'Mailing List'].include?(opts[:'mailsend_type'])
        fail ArgumentError, 'invalid value for "mailsend_type", must be one of None, Ticket Technician, Ticket Administrator, Ticket Administrator and Technician, All project members, Mailing List'
      end
      if opts[:'mail_lang'] && !['English', 'Japanese'].include?(opts[:'mail_lang'])
        fail ArgumentError, 'invalid value for "mail_lang", must be one of English, Japanese'
      end
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/admin".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["allow_anonymouse"] = opts[:'allow_anonymouse'] if !opts[:'allow_anonymouse'].nil?
      form_params["frs_autosync"] = opts[:'frs_autosync'] if !opts[:'frs_autosync'].nil?
      form_params["mailsend_type"] = opts[:'mailsend_type'] if !opts[:'mailsend_type'].nil?
      form_params["mailing_list_id"] = opts[:'mailing_list_id'] if !opts[:'mailing_list_id'].nil?
      form_params["mail_lang"] = opts[:'mail_lang'] if !opts[:'mail_lang'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketPrefs')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_project_ticket_adminprefs\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project ticket component
    # @param id_or_name numeric project id or project name
    # @param component_id numeric project ticket component id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Ticket component name
    # @option opts [String] :description Ticket component description
    # @option opts [Integer] :owner Ticket componet owner user_id
    # @option opts [BOOLEAN] :active Ticket componet will be shown the component select list when this parameter is true
    # @return [ProjectTicketComponent]
    def update_project_ticket_component(id_or_name, component_id, opts = {})
      data, _status_code, _headers = update_project_ticket_component_with_http_info(id_or_name, component_id, opts)
      return data
    end

    # 
    # Update project ticket component
    # @param id_or_name numeric project id or project name
    # @param component_id numeric project ticket component id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Ticket component name
    # @option opts [String] :description Ticket component description
    # @option opts [Integer] :owner Ticket componet owner user_id
    # @option opts [BOOLEAN] :active Ticket componet will be shown the component select list when this parameter is true
    # @return [Array<(ProjectTicketComponent, Fixnum, Hash)>] ProjectTicketComponent data, response status code and response headers
    def update_project_ticket_component_with_http_info(id_or_name, component_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_project_ticket_component ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_project_ticket_component" if id_or_name.nil?
      # verify the required parameter 'component_id' is set
      fail ArgumentError, "Missing the required parameter 'component_id' when calling ProjectApi.update_project_ticket_component" if component_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/component/{component_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'component_id' + '}', component_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = opts[:'name'] if !opts[:'name'].nil?
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["owner"] = opts[:'owner'] if !opts[:'owner'].nil?
      form_params["active"] = opts[:'active'] if !opts[:'active'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketComponent')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_project_ticket_component\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project ticket milestone
    # @param id_or_name numeric project id or project name
    # @param milestone_id numeric project ticket milestone id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Ticket milestone name
    # @option opts [String] :description Ticket milestone description
    # @option opts [DateTime] :start Ticket milestone start date
    # @option opts [DateTime] :_end Ticket milestone due date
    # @option opts [String] :force_status If you want to force close the milestone set to &#39;close&#39; or reopen it set to &#39;reopen&#39;
    # @return [ProjectTicketComponent]
    def update_project_ticket_milestone(id_or_name, milestone_id, opts = {})
      data, _status_code, _headers = update_project_ticket_milestone_with_http_info(id_or_name, milestone_id, opts)
      return data
    end

    # 
    # Update project ticket milestone
    # @param id_or_name numeric project id or project name
    # @param milestone_id numeric project ticket milestone id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Ticket milestone name
    # @option opts [String] :description Ticket milestone description
    # @option opts [DateTime] :start Ticket milestone start date
    # @option opts [DateTime] :_end Ticket milestone due date
    # @option opts [String] :force_status If you want to force close the milestone set to &#39;close&#39; or reopen it set to &#39;reopen&#39;
    # @return [Array<(ProjectTicketComponent, Fixnum, Hash)>] ProjectTicketComponent data, response status code and response headers
    def update_project_ticket_milestone_with_http_info(id_or_name, milestone_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_project_ticket_milestone ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_project_ticket_milestone" if id_or_name.nil?
      # verify the required parameter 'milestone_id' is set
      fail ArgumentError, "Missing the required parameter 'milestone_id' when calling ProjectApi.update_project_ticket_milestone" if milestone_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/milestone/{milestone_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'milestone_id' + '}', milestone_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = opts[:'name'] if !opts[:'name'].nil?
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["start"] = opts[:'start'] if !opts[:'start'].nil?
      form_params["end"] = opts[:'_end'] if !opts[:'_end'].nil?
      form_params["force_status"] = opts[:'force_status'] if !opts[:'force_status'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketComponent')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_project_ticket_milestone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project ticket type
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Ticket type name
    # @option opts [String] :description Ticket type description
    # @option opts [BOOLEAN] :is_public if set as false, this type will be shown to project members only.
    # @return [ProjectTicketType]
    def update_project_ticket_type(id_or_name, type_id, opts = {})
      data, _status_code, _headers = update_project_ticket_type_with_http_info(id_or_name, type_id, opts)
      return data
    end

    # 
    # Update project ticket type
    # @param id_or_name numeric project id or project name
    # @param type_id numeric project ticket type id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Ticket type name
    # @option opts [String] :description Ticket type description
    # @option opts [BOOLEAN] :is_public if set as false, this type will be shown to project members only.
    # @return [Array<(ProjectTicketType, Fixnum, Hash)>] ProjectTicketType data, response status code and response headers
    def update_project_ticket_type_with_http_info(id_or_name, type_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_project_ticket_type ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_project_ticket_type" if id_or_name.nil?
      # verify the required parameter 'type_id' is set
      fail ArgumentError, "Missing the required parameter 'type_id' when calling ProjectApi.update_project_ticket_type" if type_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/ticket/type/{type_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'type_id' + '}', type_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = opts[:'name'] if !opts[:'name'].nil?
      form_params["description"] = opts[:'description'] if !opts[:'description'].nil?
      form_params["is_public"] = opts[:'is_public'] if !opts[:'is_public'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProjectTicketType')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_project_ticket_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update project tools info.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :git use git flag
    # @option opts [BOOLEAN] :svn use Subversion flag
    # @option opts [BOOLEAN] :hg use Mercurial(Hg) flag
    # @option opts [BOOLEAN] :bzr use Bazaar flag
    # @option opts [BOOLEAN] :frs use File Release flag
    # @option opts [BOOLEAN] :ticket use Ticket flag
    # @option opts [BOOLEAN] :wiki use Wiki flag
    # @option opts [BOOLEAN] :forum use Forum flag
    # @option opts [BOOLEAN] :ml use Mailing List flag
    # @return [GroupToolFlags]
    def update_project_tools(id_or_name, opts = {})
      data, _status_code, _headers = update_project_tools_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Update project tools info.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :git use git flag
    # @option opts [BOOLEAN] :svn use Subversion flag
    # @option opts [BOOLEAN] :hg use Mercurial(Hg) flag
    # @option opts [BOOLEAN] :bzr use Bazaar flag
    # @option opts [BOOLEAN] :frs use File Release flag
    # @option opts [BOOLEAN] :ticket use Ticket flag
    # @option opts [BOOLEAN] :wiki use Wiki flag
    # @option opts [BOOLEAN] :forum use Forum flag
    # @option opts [BOOLEAN] :ml use Mailing List flag
    # @return [Array<(GroupToolFlags, Fixnum, Hash)>] GroupToolFlags data, response status code and response headers
    def update_project_tools_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_project_tools ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_project_tools" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/admin/tools".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["git"] = opts[:'git'] if !opts[:'git'].nil?
      form_params["svn"] = opts[:'svn'] if !opts[:'svn'].nil?
      form_params["hg"] = opts[:'hg'] if !opts[:'hg'].nil?
      form_params["bzr"] = opts[:'bzr'] if !opts[:'bzr'].nil?
      form_params["frs"] = opts[:'frs'] if !opts[:'frs'].nil?
      form_params["ticket"] = opts[:'ticket'] if !opts[:'ticket'].nil?
      form_params["wiki"] = opts[:'wiki'] if !opts[:'wiki'].nil?
      form_params["forum"] = opts[:'forum'] if !opts[:'forum'].nil?
      form_params["ml"] = opts[:'ml'] if !opts[:'ml'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GroupToolFlags')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_project_tools\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update target release. (Note: If you update draft release, the release will be public automatically.) 
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @option opts [String] :name Release name
    # @option opts [DateTime] :time Release datetime. If you set future time, the release hide until specified time.
    # @option opts [Integer] :move_to_package_id If this parameter is specified, the release move to another package.
    # @return [Release]
    def update_release(id_or_name, package_id, release_id, opts = {})
      data, _status_code, _headers = update_release_with_http_info(id_or_name, package_id, release_id, opts)
      return data
    end

    # 
    # Update target release. (Note: If you update draft release, the release will be public automatically.) 
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @option opts [String] :name Release name
    # @option opts [DateTime] :time Release datetime. If you set future time, the release hide until specified time.
    # @option opts [Integer] :move_to_package_id If this parameter is specified, the release move to another package.
    # @return [Array<(Release, Fixnum, Hash)>] Release data, response status code and response headers
    def update_release_with_http_info(id_or_name, package_id, release_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_release ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_release" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.update_release" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.update_release" if release_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["visibility"] = opts[:'visibility'] if !opts[:'visibility'].nil?
      form_params["name"] = opts[:'name'] if !opts[:'name'].nil?
      form_params["time"] = opts[:'time'] if !opts[:'time'].nil?
      form_params["move_to_package_id"] = opts[:'move_to_package_id'] if !opts[:'move_to_package_id'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Release')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_release\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Change visibility of target file.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [RelFile]
    def update_release_file(id_or_name, package_id, release_id, file_id, opts = {})
      data, _status_code, _headers = update_release_file_with_http_info(id_or_name, package_id, release_id, file_id, opts)
      return data
    end

    # 
    # Change visibility of target file.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [Array<(RelFile, Fixnum, Hash)>] RelFile data, response status code and response headers
    def update_release_file_with_http_info(id_or_name, package_id, release_id, file_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_release_file ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_release_file" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.update_release_file" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.update_release_file" if release_id.nil?
      # verify the required parameter 'file_id' is set
      fail ArgumentError, "Missing the required parameter 'file_id' when calling ProjectApi.update_release_file" if file_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}/{file_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s).sub('{' + 'file_id' + '}', file_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["visibility"] = opts[:'visibility'] if !opts[:'visibility'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RelFile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_release_file\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
